
let FuncSrc = GetCurrentScriptDirectory;
let ScriptSrc = current~"ds_system/";
let DEBUG = false;
let SKIPFALSELOADINGWAIT = true;
let SAVEPACKAGEDATA = true;
let SAVEBUILDERDATA = false;
let IgnoreInformationFile = true;

//#include"./SpellPracticeData.h"
#include"./library/Dialogue/DialogueLib.txt"

let MENU_BEGIN = -1;
let MENU_START_GAME = 0;
let MENU_START_EXTRA = 1;
let MENU_START_PRACTICE = 2;
let MENU_START_S_PRACTICE = 3;
let MENU_REPLAY = 4;
let MENU_STATS = 5;
let MENU_MUSICROOM = 6;
let MENU_OPTION = 7;
let MENU_MANUAL = 8;
let MENU_EXIT = 9;
let MENU_START_GAME_SKIP_DIFFICULTY = 10;

let MENU_RETURN_START_GAME = -2;
let MENU_RETURN_START_EXTRA = -3;

let MENU_STEP = 0;

//Used for classic difficulty select...
let DIFFICULTY_REALVAR = [12, 36, 48, 72, 96, 120];

let Global_LastSelection = [30, 0, 0]; //StartGame, CharSelect, CharMenuSelect


let FontFolder = current~"ds_system/font/";
let MenuFolder = current~"source/Menu/";
let SpellSource = current;

let RankSource = MenuFolder ~ "rank/";
let InfoSource = MenuFolder ~ "manual/";
let img_effect = current~"ds_system/img/effect.png"; // Effect Sheet
let img_frame = current~"ds_system/img/frame2.png"; // Effect Sheet

let Font_Main_Path = FontFolder ~ "Florida Project Phase One.ttf";
let Font_Main_Name = "Florida Project Phase One";
let Font_Main_Modifier = 1.3;

let Font_Sub_Path = FontFolder ~ "Florida Project Phase Two.ttf";
let Font_Sub_Name = "Florida Project Phase Two";
let Font_Sub_Modifier = 1.2;

let Font_Char_Path = FontFolder ~ "CODE2000.ttf";
let Font_Char_Name = "Code2000";
let Font_Char_Modifier = 1;

let Font_Difficult_Path = FontFolder ~ "Mangalb.ttf";
let Font_Difficult_Name = "Mangal";
let Font_Difficult_Modifier = 1.5;

let Font_Difficulty_Path = FontFolder ~ "Revue.ttf";
let Font_Difficulty_Name = "Revue";

let Font_Boss_Comment_Path = FontFolder ~ "SourceCodePro-RegularDNHEDIT.ttf";
let Font_Boss_Comment_Name = "Source Code ProDNHEDIT";


let Menu_Text = MenuFolder ~ "text.png";
let Menu_Title = MenuFolder ~ "Title.png";
let Menu_Sub = MenuFolder ~ "SubMenu.png";
let Menu_Char = MenuFolder ~ "CharSlect.png";
let Menu_Rank = MenuFolder ~ "rankselect.png";

let Character_Info = [""];

let TitleBG = ID_INVALID;
let MenuBG = ID_INVALID;
let SubMenus = [];

let CurrentBGM = ID_INVALID;
let CurrentBGMID = "";

let selection = -1;
let lastselection = -1;
let selecthold = 16;

let GlobalSounds = [];
let GlobalSndStr = [];
let ReallyPlaying = [];


let DayNames = [];
let DayImages = [];
let DayPaths = [];
let DayComments = [];
let DayAvailable = [];
let ssx = 0;
let ssy = 0;

let ScriptPreviews = [[[]]];
let ScriptNames = [[]];
let ScriptIDs = [];

let IsPlayersLoaded = false;
let IsStgFieldActive = false;
let DestroyLastInstance = false;

let options = [95, 80, 2, 3, 2, 0, 0];
let Lifebars = ["DDC", "UFO", "PCB", "RMI"];
//Lifebars = ["All Stars", "All Stars"];
let SE_VOL = options[1];
let score;


let Default_OptionData = [options, Global_LastSelection];



@Event{
	alternative(GetEventType)
	case(EV_USER+30){
		let deets = SplitString(GetEventArgument(0), "^");
		let name = deets[0];
		let vol = atoi(deets[1]);
		PlaySoundB1(name, vol);
	}
	case(EV_USER+31){
		let name = GetEventArgument(0);
		StopSoundB1(name);
	}
	case(EV_USER+32){
		let deets = SplitString(GetEventArgument(0), "^");
		let name = deets[0];
		let vol = atoi(deets[1]);
		let start = atoi(deets[2]);
		let end = atoi(deets[3]);
		let forc = false;		
		
		if(vol == 1){forc = true;}
		
		PlayMusicB1(name, vol, start, end);
	}
	// case(EV_PAUSE_ENTER){
		// ObjSound_Stop(CurrentBGM);
	// }
	// case(EV_PAUSE_LEAVE){
		// ObjSound_Play(CurrentBGM);
	// }
}



function LoadTheGame{
	if(DEBUG){return;}
	
	loop(5){yield;}
	
	let loadcomp = 0; //percent to completion
	let loadcount = 38;	//amount of images/scripts InTexture loaded
	
	
	let PreLoadText = DrawSubMenuText("Please wait...");
	Obj_SetRenderPriority(PreLoadText, 1);
	ObjRender_SetPosition(PreLoadText, 64, 454, 0);
	
	loop(9){yield;}
	ReturnToTitle(PreLoadText);
	
	// if(!InstallFont(Font_Main_Path)){RaiseError("Error when loading: Could not load font "~Font_Main_Path)}
	// if(!InstallFont(Font_Sub_Path)){RaiseError("Error when loading: Could not load font "~Font_Sub_Path)}
	// if(!InstallFont(Font_Boss_Comment_Path)){RaiseError("Error when loading: Could not load font "~Font_Boss_Comment_Path)}
	//if(!InstallFont(Font_Char_Path)){RaiseError("Error when loading: Could not load font "~Font_Char_Path)}
	//if(!InstallFont(Font_Difficult_Path)){RaiseError("Error when loading: Could not load font "~Font_Difficult_Path)}
	//if(!InstallFont(Font_Difficulty_Path)){RaiseError("Error when loading: Could not load font "~Font_Difficulty_Path)}
	
	BruteForceFont(Font_Main_Path, 8);
	BruteForceFont(Font_Sub_Path, 8);
	BruteForceFont(Font_Boss_Comment_Path, 800);
	
	let LoadText = DrawSubMenuText("Now Loading: List of Players");
	Obj_SetRenderPriority(LoadText, 1);
	ObjText_SetFontType(LoadText,Font_Main_Name);
	ObjText_SetFontSize(LoadText,18*Font_Main_Modifier);
	ObjRender_SetPosition(LoadText, 48, 424, 0);
	
	let LoadBar = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriority(LoadBar, 0.74);
	ObjPrim_SetTexture(LoadBar, NULL);
	ObjSprite2D_SetSourceRect(LoadBar, 0, 0, 1, 1);
	ObjSprite2D_SetDestRect(LoadBar, 0, -6, 196, 6);
	ObjRender_SetPosition(LoadBar, 400, 384, 0);
	ObjRender_SetScaleX(LoadBar, 0);
	
	
	Wait_Loading(5, 1);
	
	LoadAvailablePlayers(true);
	Wait_Loading(4, 4);
	
	
	
	ObjText_SetText(LoadText, "Now Loading: Sound Effects");
	
	LoadAllSoundInFolder(FuncSrc~"sound/");
	
	Wait_Loading(3, 5);
	
	ObjText_SetText(LoadText, "Now Loading: Images - Menu");
	
	LoadAllImagesInFolder(MenuFolder);
	
	Wait_Loading(6, 1);
	
	ObjText_SetText(LoadText, "Now Loading: Images - Boss");
	
	LoadAllImagesInFolder(current~"source/Boss");
	
	Wait_Loading(6, 1);
	
	ObjText_SetText(LoadText, "Now Loading: Images - Environment");
	
	LoadAllImagesInFolder(current~"source/Stage");
	
	Wait_Loading(6, 1);
	
	//LImageB(current~"img/boss/System Template/Undefined.png");
	
	/*
	
	ObjText_SetText(LoadText, "Now Loading: Supporting Scripts");
	
	*/
	
	
	ObjText_SetText(LoadText, "Now Loading: Score and Settings");
	
	LoadCommonDataAreaA1("Score");	
	LoadCommonDataAreaA1("OptionConfig");
	LoadCommonDataAreaA1("ScriptBuilderData");
	Wait_Loading(2, 1.5);
	
	
	ObjText_SetText(LoadText, "Now Loading: Boss Data");
	//SetSpellNames;
	let CharNames = GetDirectoryList(current~"source/boss/");
	let CacheNames = [];
	let CachePaths = [];
	let CacheImages = [];
	let CacheComments = [];
	let CacheAvailable = [];
	WriteLog(CharNames);
	ascent(i in 0..length(CharNames)){
		let StrPath = CharNames[i];
		let Path = StrPath[0..length(StrPath)-1][0..length(StrPath)-1];
		let Name = GetFinalDirectoriesInPathA1(Path, 1);
		ObjText_SetText(LoadText, "Now Loading: Boss Data");
		WriteLog("Now Loading: Boss Data - "~Name);
		
		//CacheAvailable = CacheAvailable~[round(rand(0.25, 1.4))];
		
		/*
		CreateSpellChoice("Testing", "", [""], [""]);
		
		["{Test Comment)[r]"~Name~"'s Nonspell"]
		*/
		
		
		//let Scripts = GetScriptPathList(Path~"/", TYPE_SCRIPT_SINGLE);
		//Scripts = GetScriptPathList(Path~"/", TYPE_SCRIPT_PLURAL)~Scripts;
		
		let Scripts = LoadAllScriptsInFolder(Path~"/", TYPE_SCRIPT_SINGLE);
		Scripts = LoadAllScriptsInFolder(Path~"/", TYPE_SCRIPT_PLURAL)~Scripts;
		
		let numScripts = length(Scripts);
		let numComments = 0;
		
		WriteLog(Scripts);
		let RealImagePath = [];
		
		
		
		let InfoFile = ObjFile_Create(OBJ_FILE_TEXT);
		ObjFile_Open(InfoFile, Path~"/Information.txt");
		let ccomment = ObjFileT_GetLineText(InfoFile, 1);
		
		ascent(i in 0..numScripts){
			let TArr = Scripts[i];
			let FName = GetFinalDirectoriesInPathA1(TArr, 1);
			let iName = ObjFileT_GetLineText(InfoFile, i+2);
			if(IgnoreInformationFile){
				iName = FName // ~ " - " ~ iName;
			}
			CacheNames = CacheNames ~ [iName];
			CachePaths = CachePaths ~ [TArr];
			CacheAvailable = CacheAvailable~[1];
			CacheImages = CacheImages~[[MenuFolder~"previews/Undefined.png"]];
			CacheComments = CacheComments~[ccomment];
		}
		
		Obj_Delete(InfoFile);
		
		
		/*
		let InfoFile = ObjFile_Create(OBJ_FILE_TEXT);
		ObjFile_Open(InfoFile, Path~"/Information.txt");
		
		let FileYSize = ObjFileT_GetLineCount(InfoFile);
		let tx = 0;
		let ty = 0;
		let SetStep = 0;
		
		let SpellNames = [RedText~"Undefined spellname for "~Name];
		let ScripterNames = [RedText~"Undefined Scripter"];
		let ImagePaths = [];
		let AttackComment = RedText~"(ZIDLE3|2)(SD0.4)Undefined comment for "~Name;
		
		let HasCommentBegun = false;
		
		while(ty < FileYSize){
			let line = ObjFileT_GetLineText(InfoFile, ty)~"()";
			
			let linelen = length(line)-2;
			
			let FirstChar = line[0..1];
			if(linelen > 0){
				if(!HasCommentBegun){
					HasCommentBegun = true;
					AttackComment = "";
					
					SpellNames = SplitString(line[0..linelen], ",");
					ty++;
					let sNames = ObjFileT_GetLineText(InfoFile, ty);
					ScripterNames = SplitString(sNames[0..length(sNames)], ",");
					ty++;
					
					let sImage = ObjFileT_GetLineText(InfoFile, ty);
					ImagePaths = SplitString(sImage[0..length(sImage)], ",");
					
					let RenderName = "(TA255|160|96)(BA192|96|0)(SD0.6)";
					ascent(i in 0..length(SpellNames)){
						RenderName = RenderName~SpellNames[i];
						if(i != length(SpellNames)-1){
							RenderName = RenderName~", ";
						}
					}
					AttackComment = AttackComment~RenderName~"(RR)";
					
					RenderName = "(SQ0)(TA96|160|255)(BA0|96|192)";
					ascent(i in 0..length(ScripterNames)){
						RenderName = RenderName~ScripterNames[i];
						if(i != length(ScripterNames)-1){
							RenderName = RenderName~", ";
						}
					}
					
					AttackComment = AttackComment~RenderName~"(SQ10)(SD0.1)(TA255|255|255)(BA192|192|192)(RR) (RR)";
				}else{
					AttackComment = AttackComment~line[0..linelen]~"(RR)";
				}
			}
			ty++;
		}
		Obj_Delete(InfoFile);
		*/
		
		/*
		let RealImagePath = [];
		ascent(i in 0..length(ImagePaths)){
			RealImagePath = RealImagePath~[current~"img/boss/"~Name~"/"~ImagePaths[i]];
			LImageB(RealImagePath[i]);
		}
		
		if(length(RealImagePath) <= 0){
			RealImagePath = [current~"img/boss/System Template/Undefined.png"];
		}
		*/
		
		//CacheImages = CacheImages~[RealImagePath];
		
		WriteToDayVariables;
		
		Wait_Loading(0, 30/length(CharNames)/1);
	}
	//WriteToDayVariables;
	
	Wait_Loading(1, 30);
	
	ScriptPreviews = erase(ScriptPreviews, 0);
	
	
	
	ReturnToTitle(LoadText);
	ReturnToTitle(LoadBar);
	
	function LImage(path){
		LoadTextureInLoadThread(path);
		Wait_Loading(1, 2);
	}
	
	function LImageB(path){
		LoadTextureInLoadThread(path);
		Wait_Loading(1, 0);
	}
	
	function LScript(path){
		LoadScript(path);
		//loop(1){yield;}
	}
	
	function Wait_Loading(time, compinc){
		loop(time){
			loadcomp+=compinc;
			ObjRender_SetScaleX(LoadBar, loadcomp/100);
			if(!SKIPFALSELOADINGWAIT){yield;}
		}
		if(SKIPFALSELOADINGWAIT&&time>0){yield;}
	}
	
	task WriteToDayVariables{
		if(length(CacheNames)>0){
			DayNames = DayNames~[CacheNames];
			DayPaths = DayPaths~[CachePaths];
			DayImages = DayImages~[CacheImages];
			DayComments = DayComments~[CacheComments];
			DayAvailable = DayAvailable~[CacheAvailable];
			CacheNames = [];
			CachePaths = [];
			CacheImages = [];
			CacheComments = [];
			CacheAvailable = [];
		}
	}

	
	function BruteForceFont(path, leng){
		ascent(i in 0..leng){
			if(InstallFont(path)){return;}
		}
		WriteLog("Failed to load font after "~IntToString(leng)~" attempts: "~Font_Boss_Comment_Path);
	}
	
	
	function LoadAllImagesInFolder(path){
		let plist = GetFilePathList(path);
		let dlist = GetDirectoryList(path);
		ascent(i in 0..length(plist)){
			let cFile = plist[i];
			let fExt = cFile[length(cFile)-3..length(cFile)];
			if(fExt == "png" || fExt == "jpg" || fExt == "bmp"){
				LoadTextureInLoadThread(cFile);
			}
		}
		ascent(i in 0..length(dlist)){
			LoadAllImagesInFolder(dlist[i]);
		}
	}
	
	function LoadAllScriptsInFolder(path, type){
		let sScript = GetScriptPathList(path, type);
		let dlist = GetDirectoryList(path);
		
		ascent(i in 0..length(dlist)){
			let value = LoadAllScriptsInFolder(dlist[i], type);
			sScript = sScript~value;
		}
		
		return sScript;
	}

	function LoadAllSoundInFolder(path){
		let plist = GetFilePathList(path);
		let dlist = GetDirectoryList(path);
		ascent(i in 0..length(plist)){
			let cFile = plist[i];
			let FName = GetFinalDirectoriesInPathA1(cFile, 1);
			let fExt = FName[length(FName)-3..length(FName)];
			if(fExt == "wav"){
				CreateObjectSound(cFile, FName[0..length(FName)-4]);
			}
		}
		ascent(i in 0..length(dlist)){
			let darr = dlist[i];
			LoadAllSoundInFolder(darr[0..length(darr)-1]~"/");
		}
	}
}


task PlaySound(name){
	let ID = -1;
	let GlobalSounds = GetCommonData("GlobalSoundData", [-1]);
	let GlobalSndStr = GetCommonData("GlobalSndStrData", [-1]);
	ascent(i in 0..length(GlobalSndStr)){
		if(GlobalSndStr[i]==name){ID = i; break;}
	}
	if(ID==-1){RaiseError("Error when attempting to play audio: "~name~" (Not Found)");}
	WriteLog(ID);
	ObjSound_SetVolumeRate(GlobalSounds[ID], SE_VOL*0.8);
	ObjSound_Play(GlobalSounds[ID]);
}

task PlaySoundB1(name, vol){
	let ID = -1;
	let GlobalSounds = GetCommonData("GlobalSoundData", [-1]);
	let GlobalSndStr = GetCommonData("GlobalSndStrData", [-1]);
	ascent(i in 0..length(GlobalSndStr)){
		if(GlobalSndStr[i]==name){ID = i; break;}
	}
	if(ID==-1){RaiseError("Error when attempting to play audio: "~name);}
	ObjSound_SetVolumeRate(GlobalSounds[ID], SE_VOL*(vol/100));
	ObjSound_Play(GlobalSounds[ID]);
}


task StopSoundB1(name){
	let ID = -1;
	let GlobalSounds = GetCommonData("GlobalSoundData", [-1]);
	let GlobalSndStr = GetCommonData("GlobalSndStrData", [-1]);
	ascent(i in 0..length(GlobalSndStr)){
		if(GlobalSndStr[i]==name){ID = i; break;}
	}
	if(ID==-1){RaiseError("Error when attempting to play audio: "~name);}
	ObjSound_Stop(GlobalSounds[ID]);
}


task FallingLeafContainer{
	while(!IsStgFieldActive){
		FallingLeafA1(rand(-64,640), rand(-64,480), 196, 196, 196, 0.7);
		loop(5-options[2]){yield;}
	}
}

task FallingLeafA1(deX, deY, colorR, colorG, colorB, deScale){
	if(options[2] == 0){return;}
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	let obj_time = 0;
	let angX = rand(-360, 360);
	let angY = rand(-360, 360);
	let angZ = rand(-360, 360);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.76);
	ObjPrim_SetTexture(obj, img_effect);
	ObjSprite2D_SetSourceRect(obj, 0, 228, 33, 251);
	ObjSprite2D_SetDestRect(obj, -16, -12, 16, 12);
	ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
	ObjRender_SetPosition(obj, deX, deY, 0);
	ObjRender_SetColor(obj, colorR, colorG, colorB);
	ObjRender_SetAlpha(obj, 0);
	
	let alpha = 0.1;
	let scale = deScale;
	let randX = rand(50, 350);
	let randY = rand(50, 350);
	let RandZ = rand(17,170);
	//atan2(randY - deX, randX - deY);
	while(obj_time<182&&options[2]>0&&!IsStgFieldActive){
		obj_time++;
		if(obj_time>150){alpha = max(alpha-3, 0)}else{alpha = min(alpha+3, 96)}
		alpha += 0.1;
		deX += randX/250;
		deY += randY/250;
		angX += randX/255;
		angY += randY/255;
		angZ += randX/295+randY/295;
		
		ObjRender_SetPosition(obj, deX, deY, 0);
		ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
		ObjRender_SetAlpha(obj, alpha);
		ObjRender_SetScaleXYZ(obj, scale, scale, scale);
		yield;
	}
	Obj_Delete(obj);
}

function TitleMenuEffect(type){

	let obj1b = CreateSpriteObject(Menu_Text);
	ObjSprite2D_SetSourceRect(obj1b, 256, 0, 511, 256);
	ObjSprite2D_SetDestRect(obj1b, -128, -128, 128, 128);
	ObjRender_SetColor(obj1b, 96, 196, 224);
	
	let obj2 = CreateSpriteObject(Menu_Text);
	ObjSprite2D_SetSourceRect(obj2, 256, 0, 511, 256);
	ObjSprite2D_SetDestRect(obj2, -128, -128, 128, 128);
	ObjRender_SetColor(obj2, 255, 255, 255);
	
	let obj1 = CreateSpriteObject(Menu_Text);
	ObjSprite2D_SetSourceRect(obj1, 256, 0, 511, 256);
	ObjSprite2D_SetDestRect(obj1, -128, -128, 128, 128);
	ObjRender_SetColor(obj1, 96, 196, 224);
	
	let objtext = CreateSpriteObject(Menu_Text);
	ObjSprite2D_SetSourceRect(objtext, 0, 0, 255, 255);
	ObjSprite2D_SetDestRect(objtext, -128, -128, 128, 128);
	
	let objHighlight = CreateSpriteObject(Menu_Text);
	ObjSprite2D_SetSourceRect(objHighlight, 256, 256, 512, 512);
	ObjSprite2D_SetDestRect(objHighlight, -128, -128, 128, 128);
	Obj_SetRenderPriority(objHighlight, 0.7);
	ObjRender_SetBlendType(objHighlight, BLEND_SUBTRACT);
	ObjRender_SetColor(objHighlight, 0, 0, 0);
	ObjRender_SetAlpha(objHighlight, 0);
	ObjRender_SetScaleXYZ(objHighlight, 3.5, 3.5, 1);
	
	let desc_col = [
		[0, 192, 192],
		[0, 192, 0],
		[192, 0, 144],
		[192, 144, 0],
		[192, 192, 0],
		[0, 80, 192],
		[192, 192, 192],
		[192, 0, 0],
	];
	
	ascent(i in 0..length(desc_col)){
		let tarr = [];
		let larr = desc_col[i];
		
		ascent(x in 0..3){
			tarr = tarr~[255-larr[x]];
		}
		
		desc_col[i] = tarr;
	}
	
	
	
	let lastlocSel = selection;
	
	let cspd = 10;
	let cspda = [cspd, cspd, cspd];
	let curc = [0, 0, 0];
	ChangeColor;
	
	let cord = [196, 144];
	SetStarPosition(cord[0], cord[1]);
	ObjRender_SetPosition(objtext, cord[0]-4, cord[1]-2, 0);
	ObjRender_SetPosition(objHighlight, 0, GetScreenHeight/12*11, 0);
	
	SetStarValues(1, 0);
	let lang = rand(0, 360);
	
	if(type == 0){
		ObjRender_SetScaleXYZ(objtext, 0, 0, 1);
		ascent(i in 0..20){
			let scl = 3-2*i/20;
			let alph = 96*i/20;
			SetStarValues(scl, alph);
			
			lang += 10;
			SetStarAngle;
			
			yield;
		}
		ascent(i in 0..10){
			let scl = i/10;
			ObjRender_SetAlpha(objtext, 255*i/10);
			ObjRender_SetScaleXYZ(objtext, scl, scl, 1);
			yield;
		}
		RunIdleAnim;
	}else{
		EnterFromTitleC1(objtext, 15, 255);
		EnterFromTitleC1(obj1, 15, 96);
		EnterFromTitleC1(obj1b, 15, 96);
		EnterFromTitleC1(obj2, 15, 96);
		RunIdleAnim;
	}
	
	task RunIdleAnim{
		let OrigBG = MenuBG;
		
		EnterFromTitleC1(objHighlight, 50, 64);
		
		while(OrigBG == MenuBG){
			if(lastlocSel != selection){
				ChangeColor;
			}
			lang+=0.9;
			SetStarAngle;
			yield;
		}
		ReturnToTitleC1(objtext, 10, 255);
		ReturnToTitleC1(obj1, 10, 96);
		ReturnToTitleC1(obj1b, 10, 96);
		ReturnToTitleC1(obj2, 10, 96);
		
		
		let endc = curc;
		descent(i in 0..10){
			let m = i/9;
			ObjRender_SetColor(objHighlight, endc[0]*m, endc[1]*m, endc[2]*m);
			yield;
		}
		
	}
	
	sub SetStarAngle{
		ObjRender_SetAngleZ(obj1, lang);
		ObjRender_SetAngleZ(obj1b, lang*0.2+22.5);
		ObjRender_SetAngleZ(obj2, -lang+22.5);
	}
	function SetStarValues(scl, alph){
		scl *= 0.9;
		ObjRender_SetScaleXYZ(obj1, scl, scl, 1);
		ObjRender_SetScaleXYZ(obj1b, scl, scl, 1);
		ObjRender_SetScaleXYZ(obj2, scl, scl, 1);
		
		ObjRender_SetAlpha(obj1, alph);
		ObjRender_SetAlpha(obj1b, alph);
		ObjRender_SetAlpha(obj2, alph);
	}
	function SetStarPosition(x, y){
		ObjRender_SetPosition(obj1, x, y, 0);
		ObjRender_SetPosition(obj1b, x, y, 0);
		ObjRender_SetPosition(obj2, x, y, 0);
	}
	task ChangeColor{
		if(selection == -1){return;}
		lastlocSel = selection;
		let llsel = lastlocSel;
		let curcd = (desc_col[llsel%length(desc_col)]-curc);
		ascent(i in 0..3){
			curcd[i] = curcd[i]/cspd;
		}
		loop(cspd){
			if(llsel != selection){break;}
			curc += curcd;
			ObjRender_SetColor(objHighlight, curc[0], curc[1], curc[2]);
			yield;
		}
	}
}


task MainMenuOld(selectmod){
	loop(2){yield;}
	
	
	if(selectmod == MENU_BEGIN){
		//this needs to run first before all else, and i'm stretched on time to optimize the positioning
		LoadTheGame;
		DisplayFPS;
	}
	
	selection = selectmod;
	lastselection = selectmod;
	
	selecthold = 13;
	let TextObjects = [];
	let TextAlphas = [];
	let TA = 0; //TextAlpha
	let TextNames = ["Game Start", "Extra Start", "Practice Start", "Spell Practice",
	"Replay", "Player Data", "Music Room", "Option", "Information", "Quit"];
	
	let IsAvailable = [1, 0, 0, 1, 0, 0, 1, 1, 0, 1];
	
	
	if(false){ //people who aren't gtbot: remove this if statement, or set false
		//minigame
		TextNames = ["Game Start", "Replay", "Option", "Information", "Quit"];
		MENU_REPLAY = 1;
		MENU_OPTION = 2;
		MENU_MANUAL = 3;
		MENU_EXIT = 4;
		IsAvailable = [1, 1, 1, 1, 1];
	}
	
	if(true){
		//All Star
		TextNames = ["Game Start", "Boss Practice", "Replay", 
		"Mima Data", "Mima Room", "Option", "Informimation", "Quit"];
		IsAvailable = [1, 1, 1, 0, 1, 1, 0, 1];
		MENU_START_GAME_SKIP_DIFFICULTY = 0;
		MENU_START_GAME = 20;
		MENU_START_EXTRA = 21;
		MENU_START_PRACTICE = 22;
		MENU_START_S_PRACTICE = 1;
		MENU_REPLAY = 2;
		MENU_STATS = 3;
		MENU_MUSICROOM = 4;
		MENU_OPTION = 5;
		MENU_MANUAL = 6;
		MENU_EXIT = 7;
	}
	
	
	let MainCord = [144, 416];
	let SubCords = []; //[[x, y, z, randx, randy]]
	ascent(i in 0..length(TextNames)){
		let locText = DrawSubMenuText(TextNames[i]);
		TextObjects = TextObjects~[locText];
		ObjText_SetHorizontalAlignment(locText, ALIGNMENT_LEFT);
		SubCords = SubCords~[[MainCord[0]-90+i*16, MainCord[1]-150+i*24, 0, 0, 0]];
		ObjRender_SetPosition(locText, SubCords[i][0], SubCords[i][1], SubCords[i][2]);
		ObjText_SetMaxWidth(locText, 180);
		ObjText_SetFontSize(locText,16*Font_Main_Modifier);
		ObjText_SetFontType(locText,Font_Main_Name);
		ObjText_SetFontBorderColor(locText,16,16,16);
		if(IsAvailable[i] == 1){
			GrantMouseProperties(locText, i, [length(TextNames[i])*16*Font_Main_Modifier, 16], 1.1);
		}
	}
	
	let OrigCords = SubCords;
	
	if(selection == MENU_BEGIN){
		ascent(i in 0..length(TextObjects)){ObjRender_SetAlpha(TextObjects[i], 0);}
		FallingLeafContainer;
		TitleBG = CreateMenuImage(Menu_Title);
		TitleMenuEffect(0);
		let RetreivedOptionsData = GetAreaCommonData("OptionConfig", "Options", Default_OptionData);
		options = RetreivedOptionsData[0];
		SE_VOL = options[1];
		SetCommonData("quality", options[2]);
		SetCommonData("lifebar", Lifebars[SafeAssignB1(Lifebars, options[6])]);
		Global_LastSelection = RetreivedOptionsData[1];
		
		score = GetAreaCommonData("Score", "Score", []);
		PlayMusic("00", false);
		
		ascent(i in 0..length(TextObjects)){
			TextAlphas = TextAlphas~[-32*(i+1)];
			if(IsAvailable[i]){ObjRender_SetColor(TextObjects[i], 160, 160, 160)}
			else{ObjRender_SetColor(TextObjects[i], 80, 80, 80)}
		}
		while(TextAlphas[length(TextAlphas)-1]<255){
			ascent(i in 0..length(TextObjects)){
				ObjRender_SetAlpha(TextObjects[i], TextAlphas[i]);
				TextAlphas[i] = min(TextAlphas[i]+12, 255);
			}
			yield;
		}
		SelectChange(1, 0);
	}else if(selection == MENU_RETURN_START_GAME){
		FallingLeafContainer;
		TitleMenuEffect(MENU_RETURN_START_GAME);
		TitleBG = CreateMenuImage(Menu_Title);
		PlayMusic("00", true);
		
		ascent(i in 0..length(TextObjects)){
			TextAlphas = TextAlphas~[-32*(i+1)];
			if(IsAvailable[i]){ObjRender_SetColor(TextObjects[i], 160, 160, 160)}
			else{ObjRender_SetColor(TextObjects[i], 80, 80, 80)}
		}
		SelectChange(2, 0);
	}else{
		TitleMenuEffect(-1);
		ReturnToTitle(MenuBG);
	}
	
	
	let pSel = selection;
	
	// -------------------- Loop starts here --------------
	
	loop{
		if(MovePlayerCursor(IsAvailable, length(TextObjects)-1, 13, 7) != 0){
			// ShakeText;
		}
		
		if(pSel!=selection){
			pSel = selection;
			ShakeText;
		}
		
		
		
		ascent(i in 0..length(TextObjects)){
			let LocCord = SubCords[i];

			SubCords[i] = [LocCord[0], LocCord[1], LocCord[2], max(0, LocCord[3]-0.35), 
			max(0, LocCord[4]-0.35)];
			
			ObjRender_SetPosition(TextObjects[i], LocCord[0]+rand(-LocCord[3], LocCord[3]), 
			LocCord[1]+rand(-LocCord[4], LocCord[4]), LocCord[2]);
			
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else if(!IsAvailable[i]){
				ObjRender_SetColor(TextObjects[i], 80, 80, 80);
			}else{
				ObjRender_SetColor(TextObjects[i], 160, 160, 160);
			}
		}
		
		if(CheckForMenuAction("Confirm")){
			PlaySound("se_ok00");
			break;
		}
		if(CheckForMenuAction("Cancel")){
			PlaySound("se_cancel00");
			if(selection!=MENU_EXIT){
				selection = MENU_EXIT;
				ShakeText;
			}else{
				break;
			}
		}
		yield;
	}
	
	
	RegisterGameFunc(selection);
	
	descent(x in 0..14){
		ascent(i in 0..length(TextObjects)){
			ObjRender_SetAlpha(TextObjects[i], 255*(x/14));
			ObjRender_SetX(TextObjects[i], ObjRender_GetX(TextObjects[i])-(x/7));
		}
		ObjRender_SetAlpha(MenuBG, 255-255*(x/14));
		yield;
	}
	ascent(i in 0..length(TextObjects)){
		Obj_Delete(TextObjects[i]);
	}
	
	function SelectChange(num, tr){
		//defunct, kept for reference
		if(tr){PlaySound("se_select00");}
		selecthold += 7;
		lastselection = selection;
		selection+=num;
		if(selection<0){selection=length(TextObjects)-1}
		if(selection>=length(TextObjects)){selection=0}
		while(!IsAvailable[selection]){
			selection+=num;
		}
		let rz = SubCords[selection];
		SubCords[selection] = [rz[0], rz[1], rz[2], rz[3], 4.75];
	}
	sub ShakeText{
		let rz = SubCords[selection];
		SubCords[selection] = [rz[0], rz[1], rz[2], rz[3], 4.75];
	}
}

task MainMenu(selectmod){
	loop(2){yield;}
	
	
	if(selectmod == MENU_BEGIN){
		//this needs to run first before all else, and i'm stretched on time to optimize the positioning
		LoadTheGame;
		DisplayFPS;
	}
	
	selection = selectmod;
	lastselection = selectmod;
	
	selecthold = 13;
	let TextObjects = [];
	let TextAlphas = [];
	let TA = 0; //TextAlpha
	let TextNames = ["Game Start", "Extra Start", "Practice Start", "Spell Practice",
	"Replay", "Player Data", "Music Room", "Option", "Information", "Quit"];
	
	let IsAvailable = [1, 0, 0, 1, 0, 0, 1, 1, 0, 1];
	
	
	if(false){ //people who aren't gtbot: remove this if statement, or set false
		//minigame
		TextNames = ["Game Start", "Replay", "Option", "Information", "Quit"];
		MENU_REPLAY = 1;
		MENU_OPTION = 2;
		MENU_MANUAL = 3;
		MENU_EXIT = 4;
		IsAvailable = [1, 1, 1, 1, 1];
	}
	
	if(false){
		//All Star
		TextNames = ["Game Start", "Boss Practice", "Replay", 
		"Mima Data", "Mima Room", "Option", "Informimation", "Quit"];
		IsAvailable = [1, 1, 1, 0, 1, 1, 0, 1];
		MENU_START_GAME_SKIP_DIFFICULTY = 0;
		MENU_START_GAME = 20;
		MENU_START_EXTRA = 21;
		MENU_START_PRACTICE = 22;
		MENU_START_S_PRACTICE = 1;
		MENU_REPLAY = 2;
		MENU_STATS = 3;
		MENU_MUSICROOM = 4;
		MENU_OPTION = 5;
		MENU_MANUAL = 6;
		MENU_EXIT = 7;
	}
	
	if(true){
		//compilation
		TextNames = ["Game Start", "Replay", "Option", "Quit"];
		IsAvailable = [1, 1, 1, 1, 1, 1, 0, 1];
		MENU_START_GAME_SKIP_DIFFICULTY = 0;
		MENU_START_GAME = 20;
		MENU_START_EXTRA = 21;
		MENU_START_PRACTICE = 22;
		MENU_START_S_PRACTICE = 23;
		MENU_REPLAY = 1;
		MENU_STATS = 24;
		MENU_MUSICROOM = 25;
		MENU_OPTION = 2;
		MENU_MANUAL = 24;
		MENU_EXIT = 3;
	}
	
	let MainCord = [144, 416];
	let SubCords = []; //[[x, y, z, randx, randy]]
	ascent(i in 0..length(TextNames)){
		let locText = DrawSubMenuText(TextNames[i]);
		TextObjects = TextObjects~[locText];
		ObjText_SetHorizontalAlignment(locText, ALIGNMENT_LEFT);
		SubCords = SubCords~[[MainCord[0]-90+i*16, MainCord[1]-150+i*24, 0, 0, 0]];
		ObjRender_SetPosition(locText, SubCords[i][0], SubCords[i][1], SubCords[i][2]);
		ObjText_SetMaxWidth(locText, 180);
		ObjText_SetFontSize(locText,16*Font_Main_Modifier);
		ObjText_SetFontType(locText,Font_Main_Name);
		ObjText_SetFontBorderColor(locText,16,16,16);
		if(IsAvailable[i] == 1){
			GrantMouseProperties(locText, i, [length(TextNames[i])*16*Font_Main_Modifier, 16], 1.1);
		}
	}
	
	let OrigCords = SubCords;
	
	if(selection == MENU_BEGIN){
		ascent(i in 0..length(TextObjects)){ObjRender_SetAlpha(TextObjects[i], 0);}
		FallingLeafContainer;
		TitleBG = CreateMenuImage(Menu_Title);
		TitleMenuEffect(0);
		let RetreivedOptionsData = GetAreaCommonData("OptionConfig", "Options", Default_OptionData);
		options = RetreivedOptionsData[0];
		SE_VOL = options[1];
		SetCommonData("quality", options[2]);
		SetCommonData("lifebar", Lifebars[SafeAssignB1(Lifebars, options[6])]);
		Global_LastSelection = RetreivedOptionsData[1];
		
		score = GetAreaCommonData("Score", "Score", []);
		PlayMusic("00", false);
		
		ascent(i in 0..length(TextObjects)){
			TextAlphas = TextAlphas~[-32*(i+1)];
			if(IsAvailable[i]){ObjRender_SetColor(TextObjects[i], 160, 160, 160)}
			else{ObjRender_SetColor(TextObjects[i], 80, 80, 80)}
		}
		while(TextAlphas[length(TextAlphas)-1]<255){
			ascent(i in 0..length(TextObjects)){
				ObjRender_SetAlpha(TextObjects[i], TextAlphas[i]);
				TextAlphas[i] = min(TextAlphas[i]+12, 255);
			}
			yield;
		}
		SelectChange(1, 0);
	}else if(selection == MENU_RETURN_START_GAME){
		TitleMenuEffect(MENU_RETURN_START_GAME);
		FallingLeafContainer;
		TitleBG = CreateMenuImage(Menu_Title);
		PlayMusic("00", true);
		
		ascent(i in 0..length(TextObjects)){
			TextAlphas = TextAlphas~[-32*(i+1)];
			if(IsAvailable[i]){ObjRender_SetColor(TextObjects[i], 160, 160, 160)}
			else{ObjRender_SetColor(TextObjects[i], 80, 80, 80)}
		}
		SelectChange(2, 0);
	}else{
		TitleMenuEffect(-1);
		ReturnToTitle(MenuBG);
	}
	
	
	let pSel = selection;
	
	// -------------------- Loop starts here --------------
	
	loop{
		if(MovePlayerCursor(IsAvailable, length(TextObjects)-1, 13, 7) != 0){
			// ShakeText;
		}
		
		if(pSel!=selection){
			pSel = selection;
			ShakeText;
		}
		
		
		
		ascent(i in 0..length(TextObjects)){
			let LocCord = SubCords[i];

			SubCords[i] = [LocCord[0], LocCord[1], LocCord[2], max(0, LocCord[3]-0.35), 
			max(0, LocCord[4]-0.35)];
			
			ObjRender_SetPosition(TextObjects[i], LocCord[0]+rand(-LocCord[3], LocCord[3]), 
			LocCord[1]+rand(-LocCord[4], LocCord[4]), LocCord[2]);
			
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else if(!IsAvailable[i]){
				ObjRender_SetColor(TextObjects[i], 80, 80, 80);
			}else{
				ObjRender_SetColor(TextObjects[i], 160, 160, 160);
			}
		}
		
		if(CheckForMenuAction("Confirm")){
			PlaySound("se_ok00");
			break;
		}
		if(CheckForMenuAction("Cancel")){
			PlaySound("se_cancel00");
			if(selection!=MENU_EXIT){
				selection = MENU_EXIT;
				ShakeText;
			}else{
				break;
			}
		}
		yield;
	}
	
	
	RegisterGameFunc(selection);
	
	descent(x in 0..14){
		ascent(i in 0..length(TextObjects)){
			ObjRender_SetAlpha(TextObjects[i], 255*(x/14));
			ObjRender_SetX(TextObjects[i], ObjRender_GetX(TextObjects[i])-(x/7));
		}
		ObjRender_SetAlpha(MenuBG, 255-255*(x/14));
		yield;
	}
	ascent(i in 0..length(TextObjects)){
		Obj_Delete(TextObjects[i]);
	}
	
	function SelectChange(num, tr){
		//defunct, kept for reference
		if(tr){PlaySound("se_select00");}
		selecthold += 7;
		lastselection = selection;
		selection+=num;
		if(selection<0){selection=length(TextObjects)-1}
		if(selection>=length(TextObjects)){selection=0}
		while(!IsAvailable[selection]){
			selection+=num;
		}
		let rz = SubCords[selection];
		SubCords[selection] = [rz[0], rz[1], rz[2], rz[3], 4.75];
	}
	sub ShakeText{
		let rz = SubCords[selection];
		SubCords[selection] = [rz[0], rz[1], rz[2], rz[3], 4.75];
	}
}


	
function RegisterGameFunc(type){
	/*
	//Mini game selection
	alternative(selection)
	case(MENU_START_GAME){StartGame_DifficultySlider;}
	case(MENU_REPLAY){ReplaySceneSelection;}
	case(MENU_OPTION){SetOptionsMenu;}
	case(MENU_MANUAL){ManualMenu;}
	case(MENU_EXIT){EndGame;}
	*/
	
	//Main game selection
	alternative(type)
	case(MENU_START_GAME){StartGame_DifficultySlider;}
	case(MENU_START_EXTRA){}
	case(MENU_START_PRACTICE){}
	case(MENU_START_S_PRACTICE){StartGame_SceneSelect(MENU_START_S_PRACTICE, 0);} //SpellPractice;}
	case(MENU_REPLAY){ReplaySceneSelection;}
	case(MENU_STATS){}
	case(MENU_MUSICROOM){MusicRoom;}
	case(MENU_OPTION){SetOptionsMenu;}
	case(MENU_MANUAL){}
	case(MENU_EXIT){EndGame;}
	case(MENU_START_GAME_SKIP_DIFFICULTY){
		
			CharacterSelect(MENU_RETURN_START_GAME);
	// StartGame_SceneSelect(MENU_START_GAME_SKIP_DIFFICULTY, 0);
	} //CharacterSelect(MENU_START_GAME_SKIP_DIFFICULTY);}
	
	case(MENU_RETURN_START_GAME){
		MainMenu(-MENU_RETURN_START_GAME-1 - 1);
	}
	
	ReturnToTitle(MenuBG);
	MenuBG = CreateMenuImage(Menu_Sub);
	
}


task CharacterSelect(type){
	yield;
	LoadAvailablePlayers(false);
	let playercount = GetFreePlayerScriptCount;
	let pinfo = [];
	
	ascent(i in 0..playercount){
		pinfo = pinfo~[[
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_PATH),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_ID),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_TITLE),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_TEXT),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_IMAGE),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_REPLAY_NAME),
		]];
	}
	
	selection = SafeAssignA1(Global_LastSelection[1], length(pinfo)-1);
	lastselection = 0;
	selecthold = 16;
	
	let menuselect = SafeAssignA1(Global_LastSelection[2], length(pinfo)-1); //For the scroll effect
	let menucap = 8; // The amount of players shown maximum
	let LocalIsSelecting = true;
	
	let TextObjects = [];
	let TextAlphas = [];
	let Cord = [380, 96];
	
	let TextFontSize = 16*Font_Char_Modifier;
	ascent(i in 0..length(pinfo)){
		TextObjects = TextObjects~[DrawSubMenuTextB1(pinfo[i][2])];
		//ObjText_SetFontType(TextObjects[i],Font_Char_Name);
		ObjText_SetFontSize(TextObjects[i],TextFontSize);
		ObjText_SetHorizontalAlignment(TextObjects[i], ALIGNMENT_LEFT);
		ObjText_SetFontColorTop(TextObjects[i],224,224,224);
		ObjText_SetFontColorBottom(TextObjects[i],96,96,255);
		TextAlphas = TextAlphas~[0];
	}
	CreateNewProfile(pinfo[selection], selection, 1);
	loop{
		ascent(i in 0..length(TextObjects)){
			ObjRender_SetAlpha(TextObjects[i], TextAlphas[i]);
			TextAlphas[i] = min(TextAlphas[i]+10, 255);
			ObjRender_SetPosition(TextObjects[i], Cord[0], Cord[1]-32+(i-menuselect)*TextFontSize, 0);
			Obj_SetVisible(TextObjects[i], true);
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else{
				ObjRender_SetColor(TextObjects[i], 128, 128, 128);
				if(i-menuselect<0||i-menuselect>menucap-1){
					Obj_SetVisible(TextObjects[i], false);
				}
			}
		}
		
		if(GetVirtualKeyState(VK_UP)!=KEY_FREE&&GetVirtualKeyState(VK_DOWN)==KEY_FREE){
			if(GetVirtualKeyState(VK_UP) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_UP) == KEY_PUSH || selecthold == 0){
				MenuMove(-1);
				PlaySound("se_select00");
				if(selection-menuselect<0&&menuselect>0){
					menuselect--;
				}
				if(selection<0){
					selection = length(TextObjects)-1;
					menuselect = length(TextObjects)-min(length(TextObjects), menucap);
				}
				CreateNewProfile(pinfo[selection], selection, 1);
			}
			selecthold--;
		}else
		if(GetVirtualKeyState(VK_DOWN)!=KEY_FREE){
			if(GetVirtualKeyState(VK_DOWN) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_DOWN) == KEY_PUSH || selecthold == 0){
				MenuMove(1);
				PlaySound("se_select00");
				if(selection>length(TextObjects)-1){
					selection = 0;
					menuselect = 0;
				}
				if(selection-menuselect>menucap-1){
					menuselect++;
				}
				CreateNewProfile(pinfo[selection], selection, -1);
			}
			selecthold--;
		}else{selecthold = 16;}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			StartTheScene(type, pinfo[selection], "");
			PlaySound("se_ok00");
			break;
		}
		if(GetVirtualKeyState(VK_SPELL)==KEY_PUSH){
			//StartGame_Difficulty;
			RegisterGameFunc(type);
			PlaySound("se_cancel00");
			break;
		}
		yield;
	}
	Global_LastSelection[1] = selection;
	Global_LastSelection[2] = menuselect;
	SaveOptionsAreaData;
	LocalIsSelecting = false;
	ascent(i in 0..length(TextObjects)){
		ReturnToTitle(TextObjects[i]);
	}
	yield;	
	
	
	task CreateNewProfile(info, select, mod){
		// path, id, title, text, image, replay name
		
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		let localalpha = 60;
		let img = info[4];
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.74);
		ObjPrim_SetTexture(obj, img);
		ObjSprite2D_SetSourceRect(obj, 0, 0, GetTextureWidth(img)-1, GetTextureHeight(img)-1);
		ObjSprite2D_SetDestRect(obj, -GetTextureWidth(img)/2, 0, GetTextureWidth(img)/2, GetTextureHeight(img));
		ObjRender_SetPosition(obj, GetTextureWidth(img)/2, 0, 0);
		
		
		let objTxt = DrawLocalCommentText(info[3]);
		let objTxtRep = DrawLocalCommentText("Player ID: "~info[1]~"[r]Replay ID: "~info[5]);
		ObjText_SetFontSize(objTxtRep,12*Font_Char_Modifier);
		
		ObjRender_SetPosition(objTxt, Cord[0]-48, Cord[1]+200, 0);
		ObjRender_SetPosition(objTxtRep, Cord[0]-32, Cord[1]+150, 0);
			
		descent(i in 0..15){
			ObjRender_SetAngleY(obj, 90/15*i);
			localalpha = 255-255/15*i;
			CheckStillActive;
			DoCasualChecks;
			yield;
		}
		
		loop{
			CheckStillActive;
			DoCasualChecks;
			yield;
		}
		
		descent(i in 0..10){
			ObjRender_SetAngleY(obj, 90-90/10*i);
			localalpha = 25.5*i;
			DoCasualChecks;
			yield;
		}
		Obj_Delete(obj);
		Obj_Delete(objTxt);
		Obj_Delete(objTxtRep);
		
		sub CheckStillActive{
			if(!LocalIsSelecting){break;}
			if(selection!=select){break;}
		}
		sub DoCasualChecks{
			ObjRender_SetAlpha(obj, localalpha);
			ObjRender_SetAlpha(objTxt, localalpha);
			ObjRender_SetAlpha(objTxtRep, localalpha);
		}
		
		function DrawLocalCommentText(txtStr){
			let objTxt = ObjText_Create;
			ObjText_SetText(objTxt,txtStr);
			//ObjText_SetFontType(objTxt,Font_Char_Name);
			ObjText_SetFontSize(objTxt,15*Font_Char_Modifier);
			ObjText_SetFontColorTop(objTxt,224,224,224);
			ObjText_SetFontColorBottom(objTxt,96,96,255);
			ObjText_SetFontBorderType(objTxt,BORDER_FULL);
			ObjText_SetFontBorderColor(objTxt,48,48,48);
			ObjText_SetFontBorderWidth(objTxt,1);
			ObjText_SetHorizontalAlignment(objTxt, ALIGNMENT_LEFT);
			ObjText_SetMaxWidth(objTxt, 900);
			Obj_SetRenderPriority(objTxt, 0.75);
			return objTxt
		}
	}
}



task StartGame_Difficulty{
	yield;
	selection = Global_LastSelection[0];
	
	let TextObjects = [];
	
	let sp = 144;
	
	let Cord = [320, 240, sp*selection];
	let objMark = CreateSelectMarker;
	ObjRender_SetPosition(objMark, Cord[0], Cord[1], 0);
	ObjRender_SetAlpha(objMark, 96);
	
	ascent(i in 0..length(DIFFICULTY_REALVAR)){
		TextObjects = TextObjects~[CreateSpriteObject(Menu_Rank)];
		ObjRender_SetPosition(TextObjects[i], Cord[0]-sp*i+Cord[2], Cord[1]+sp*i+Cord[2], 0);
		ObjSprite2D_SetSourceRect(TextObjects[i], 512, 160*i, 1023, 160*(i+1)-1);
		ObjSprite2D_SetDestCenter(TextObjects[i]);
		ObjRender_SetScaleXYZ(TextObjects[i], 0.5, 0.5, 0.5);
	}
	
	loop{
		if(GetVirtualKeyState(VK_UP)==KEY_PUSH){selection--;PlaySound("se_select00");}
		if(GetVirtualKeyState(VK_DOWN)==KEY_PUSH){selection++;PlaySound("se_select00");}
		if(selection<0){selection=5}
		if(selection>5){selection=0}
		
		ascent(i in 0..length(TextObjects)){
			let dist = GetDistanceB1(Cord[2], sp*selection);
			if(dist>1){
				Cord[2] = Cord[2]+(dist/24)*sin(atan2(sp*selection-Cord[2], Cord[0]-Cord[0]));
				}else{Cord[2] = sp*selection}
			ObjRender_SetPosition(TextObjects[i], Cord[0]+sp*i-Cord[2], Cord[1]+sp*i-Cord[2], 0);
			if(selection == i){
				ObjSprite2D_SetSourceRect(TextObjects[i], 0, 160*i, 511, 160*(i+1)-1);
			}else{
				ObjSprite2D_SetSourceRect(TextObjects[i], 512, 160*i, 1023, 160*(i+1)-1);
			}
			ObjSprite2D_SetDestCenter(TextObjects[i]);
		}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			SetCommonData("StageDiffic", -1); //remember to get rid of this 
			SetAreaCommonData("GlobalVariables", "GameDifficulty", DIFFICULTY_REALVAR[selection]);
			PlaySound("se_ok00");
			CharacterSelect(MENU_START_GAME);
			break;
		}
		if(GetVirtualKeyState(VK_BOMB)==KEY_PUSH){
			PlaySound("se_cancel00");
			MainMenu(MENU_START_GAME);
			break;
		}
		yield;
	}
	Global_LastSelection[0] = selection;
	SaveOptionsAreaData;
	ascent(i in 0..length(TextObjects)){
		Obj_Delete(TextObjects[i]);
	}
	Obj_Delete(objMark);
}

task StartGame_DifficultySlider{
	yield;
	selection = Global_LastSelection[0];
	let codeselect = truncate(selection/10)-1;
	let diff_sel = selection;
	let selecthold = -16;
	let selectinc = 0;
	
	
	
	// 1 - Very Easy (12) 
	// 2 - Easy (24)
	// 3 - Normal (36)
	// 4 - Hard (48)
	// 5 - Challenging (60)
	// 6 - Lunatic (72)
	// 7 - Overdrive (84)
	// 8 - Ultra (96)
	// 9 - Ice Fairy (108)
	// 10 - Absurd (120)
	
	
	let desc_col = [
		[192, 240, 192], //peaceful
		[96, 196, 96], //easy
		[64, 108, 255], //normal
		[232, 48, 24], //hard
		[208, 48, 144], //challenging
		[204, 0, 160], //lunatic
		[224, 16, 16], //overdrive
		[255, 128, 0], //ultra
		[0, 228, 240], //cirno
		[176, 176, 176], //absurdly extra
	];
	
	let desc_colmod = [];
	let newdesc_col = [];
	let mod = 0.8;
	ascent(i in 0..length(desc_col)){
		let temp_desc = desc_col[i];
		ascent(x in 0..3){
			temp_desc[x] = temp_desc[x] * mod;
		}
		newdesc_col = newdesc_col ~ [temp_desc];
	}
	desc_col = newdesc_col;
	
	
	let veasy_desc = ["Simple", "You've got to be kidding..."]; 
	let yudesc = [
		["PEACEFUL", "What a joke."],
		["EASY", "Not very convincing."],
		["NORMAL", "It makes you think..."],
		["HARD", "Perhaps magic is real? No, impossible."],
		["CHALLENGING", "Fairly convincing..."],
		["LUNATIC", "How do you explain this?"],
		["OVERDRIVE", "What is the meaning of this!?"],
		["ULTRA", "I can't believe what I'm seeing!"],
		["CIRNO", "Magic can't be real.. woah!!"],
		["ABSURD", "Undeniable evidence!!"]
	];
	
	let generic_desc = [
		["Peaceful", "The enemies are barely even a threat."],
		["Easy", "Not too many bullets."],
		["Normal", "Not too hard but not too easy."],
		["Hard", "The way the game was designed."],
		["Challenging", "Ramp up the difficulty a tad."],
		["Lunatic", "Not for the faint of heart."],
		["Overdrive", "The screen starts to become less visible."],
		["Ultra", "Every attack has been souped up!"],
		["Cirno", "As hard as if you were a small ice fairy!"],
		["Absurd", "Don't expect to play fair!"]
	];
	
	let desc = generic_desc;
	
	let txt_dDebug = DrawSubMenuText("");
	ObjRender_SetPosition(txt_dDebug, 32, 32, 0);
	
	let txt_dName = DrawSubMenuText(desc[codeselect][0]);
	ObjText_SetFontSize(txt_dName,32*Font_Difficult_Modifier);
	ObjText_SetFontType(txt_dName,Font_Difficult_Name);
	ObjRender_SetPosition(txt_dName, 64, 64, 0);
	ObjText_SetFontBorderType(txt_dName,BORDER_SHADOW);
	ObjText_SetFontBorderWidth(txt_dName,4);
	
	let txt_dDesc = DrawSubMenuText(desc[codeselect][1]);
	ObjText_SetFontSize(txt_dDesc,16*Font_Difficult_Modifier);
	ObjText_SetFontType(txt_dDesc,Font_Difficult_Name);
	ObjRender_SetPosition(txt_dDesc, 96, 108, 0);
	ObjText_SetFontBorderType(txt_dDesc,BORDER_SHADOW);
	ObjText_SetFontBorderWidth(txt_dDesc,2);
	
	let txt_dWarning = DrawSubMenuText("Play difficulties above Overdrive at your own risk!");
	ObjText_SetFontSize(txt_dWarning,13*Font_Difficult_Modifier);
	ObjText_SetFontType(txt_dWarning,Font_Difficult_Name);
	ObjRender_SetPosition(txt_dWarning, 112, 128, 0);
	ObjRender_SetColor(txt_dWarning, 255, 32, 32);
	ObjText_SetFontBorderColor(txt_dWarning,32,0,0);
	ObjText_SetFontBorderWidth(txt_dWarning,1);
	Obj_SetVisible(txt_dWarning, false);
	
	let bar_c = [320, 404, 208, 416];
	
	let bar_out = CreateSpriteObject(RankSource~"rankselect.png");
	ObjSprite2D_SetSourceRect(bar_out, 1, 33, 512, 64);
	ObjSprite2D_SetDestCenter(bar_out);
	ObjRender_SetPosition(bar_out, bar_c[0], bar_c[1], 0);
	
	let bar_sel = CreateSpriteObject(RankSource~"rankselect.png");
	Obj_SetRenderPriority(bar_sel, 0.76);
	ObjSprite2D_SetSourceRect(bar_sel, 33, 65, 64, 96);
	ObjSprite2D_SetDestCenter(bar_sel);
	ObjRender_SetPosition(bar_sel, bar_c[0]-264+bar_c[3]/90*selection, bar_c[1], 0);
	
	
	let txt_diffnum = [];
	ascent(i in -4..6){
		let temp_diffnum = DrawSubMenuText(IntToString(i+5));
		let tar = desc_col[i+4];
		txt_diffnum = txt_diffnum ~ [temp_diffnum];
		ObjText_SetHorizontalAlignment(temp_diffnum, ALIGNMENT_CENTER);
		ObjText_SetMaxWidth(temp_diffnum, 48);
		ObjText_SetFontSize(temp_diffnum,24*Font_Difficult_Modifier);
		ObjRender_SetPosition(temp_diffnum, bar_c[0]+bar_c[2]/4.5*i-bar_c[2]/5-16, bar_c[1]-20, 0);
		ObjRender_SetColor(temp_diffnum, tar[0], tar[1], tar[2]);
	}
	
	
	//if(diff_sel%10 == 0)
		//MoveToRGB(desc_col[codeselect], desc_col[codeselect+1]);
	//
	
	/*
	ObjText_SetFontBorderType(objTxt,BORDER_FULL);
	ObjText_SetFontBorderColor(objTxt,48,48,48);
	ObjText_SetFontBorderWidth(objTxt,1);
	*/
	
	loop{
		// ------- User Input Control --------------------- 
		
		if(IsAllKeysFree){selecthold = -16}
		if(GetVirtualKeyState(VK_RIGHT)==KEY_FREE){
			if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH||selecthold>3){
				selection = max(selection-1-max(min(selecthold, 2), 0), 10);
				ChangeDiff;
			}
			if(GetVirtualKeyState(VK_LEFT)==KEY_HOLD){selecthold++;}else{selecthold = -16;}
		}else{
			if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH||selecthold>3){
				selection = min(selection+1+max(min(selecthold, 2), 0), 100);
				ChangeDiff;
			}
			if(GetVirtualKeyState(VK_RIGHT)==KEY_HOLD){selecthold++;}else{selecthold = -16;}
		}
		ObjText_SetText(txt_dDebug,selection);
		
		// ------- Bar Coloring --------------------- 
		
		Obj_SetVisible(txt_dWarning, selection > 70);
		
		let rgbd = desc_col[SafeAssignA1(codeselect+1, length(desc_col)-1)] - desc_col[codeselect];
		let start = desc_col[codeselect];
		let tar = start;
		tar[0] = start[0]+rgbd[0]*(selection%10/10);
		tar[1] = start[1]+rgbd[1]*(selection%10/10);
		tar[2] = start[2]+rgbd[2]*(selection%10/10);
		ObjRender_SetColor(bar_out, tar[0], tar[1], tar[2]);
		
		// ------- Difficulty Number Control --------------------- 
		
		
		ascent(i in 0..length(txt_diffnum)){
			let mod = max(0.5, min(1-absolute(i*10-selection)/100, 1));
			let tar = desc_col[i];
			ObjRender_SetColor(txt_diffnum[i], tar[0]*mod, tar[1]*mod, tar[2]*mod);
		}
		
		// ------- User Accept/Exit Control --------------------- 
		
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			SetCommonData("StageDiffic", -1); //remember to get rid of this 
			SetAreaCommonData("GlobalVariables", "GameDifficulty", selection/10*12);
			SetAreaCommonData("GlobalVariables", "GameDifficultyColor", tar);
			SetAreaCommonData("GlobalVariables", "GameDifficultyString", yudesc[codeselect][0]);
			PlaySound("se_ok00");
			CharacterSelect(MENU_START_GAME);
			break;
		}
		if(GetVirtualKeyState(VK_BOMB)==KEY_PUSH){
			PlaySound("se_cancel00");
			MainMenu(MENU_START_GAME);
			break;
		}
		yield;
	}
	Global_LastSelection[0] = selection;
	SaveOptionsAreaData;
	
	ascent(i in 0..length(txt_diffnum)){
		ReturnToTitle(txt_diffnum[i]);
	}
	ReturnToTitle(txt_dName);
	ReturnToTitle(txt_dDesc);
	ReturnToTitle(txt_dDebug);
	ReturnToTitle(txt_dWarning);
	ReturnToTitle(bar_out);
	ReturnToTitle(bar_sel);
	
	sub ChangeDiff{
		ObjRender_SetPosition(bar_sel, bar_c[0]-264+bar_c[3]/90*selection, bar_c[1], 0);
		codeselect = truncate(selection/10)-1;
		selecthold = 0;
		if(diff_sel != selection){
			PlaySound("se_select00");
			diff_sel = selection;
		}
		ObjText_SetText(txt_dName,desc[codeselect][0]);
		ObjText_SetText(txt_dDesc,desc[codeselect][1]);
	}
}

task StartGame_SceneSelect(src, startup){
	yield;
	yield;
	
	selection = ssy;
	
	let lCord = [GetScreenWidth/9, GetScreenHeight/2];
	let rCord = [GetScreenWidth/6*5, GetScreenHeight/2];
	let SkipPix = 15*Font_Sub_Modifier;
	
	let sh = 13; //Disallows selection moving until its 0 
	let sx = ssx; //Controls the days
	let sy = ssy; //Controls the scenes
	let lx = ssx; //Previous sx value
	let ly = ssy; //Previous sy value
	let dir = 1; //Direction the day name will go when changing pages
	let sCancel = 0; //When holding X, sCancel++; 
						//If < sCanHold when KEY_FREE, remove from Spellbuild, otherwise, go to mainmenu
	let sCanHold = 20;
	
	let preScene = [];
	let ps = 0;
	
	let IsSelectionAvailable = DayAvailable[sx][sy];
	
	if(src == MENU_START_S_PRACTICE){preScene = ["Start Game"];ps = 1;}
	else{lCord[0] = lCord[0]+28;}
	
	let curDayScenes = preScene~DayNames[sx];
	let curTextObjects = [];
	let DayName = ID_INVALID;
	let DayComment = ID_INVALID;
	
	
	RedrawMenu(startup);
	DrawNewCutin; //ONLY FOR THIS PACKAGE
	
	let FinalBuild = GetAreaCommonData("ScriptBuilderData", "FinalBuild", [[-1, -1]]);
	
	if(FinalBuild[0][0] == -1){
		FinalBuild = [];
	}
	
	let fblength = 0; //is set in Control_PracticeMenu
	let curBuildObjects = [];
	
	if(src == MENU_START_S_PRACTICE){
		ascent(i in 0..length(FinalBuild)){
			let fb = FinalBuild[i];
			CreateBuildName(DayNames[fb[0]][fb[1]-1]);
		}
	}
	loop(length(curDayScenes)){yield;}
	loop{
		// ------- User Control --------------------- 
		
		
		if(sh == 0){
			if(src == MENU_START_S_PRACTICE){Control_PracticeMenu;}else{Control_StartGameMenu;}
			if(fblength < 10){MovePlayerCursor([-1], length(curTextObjects)-1, 10, 6);}
			//if(sh == 1){selection = min(ly, length(curDayScenes)-1);}
		}
		sh = max(0, sh-1);
		
		// ------- User Scene Control --------------------- 
		
		// if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){
			// PlaySound("se_ok00");
			// DrawNewCutin;
			// ChangeDay(-1);
		// }
		// if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){
			// PlaySound("se_ok00");
			// DrawNewCutin;
			// ChangeDay(1);
		// }
		
		
		
		if(selection != sy){
			ly = sy;
			sy = selection;
			if(sy != -1+ps){
				IsSelectionAvailable = DayAvailable[sx][sy-ps];
			}
			//DrawNewCutin;
		}
		
		
		// ------- Display Control --------------------- 
		let mod = 1;
		if(fblength==10){mod = 0.6;}
		ascent(i in 0..length(curTextObjects)){
			let curObj = curTextObjects[i];
			let lm = mod;
			if(i == 0){lm = 1;}
			let col = 128*lm;
			if(i == sy){
				col = 255*lm;
				ObjRender_SetColor(curObj, col, col, col);
			}else{ObjRender_SetColor(curObj, col, col, col);}
			
		}
		
		
		yield;
	}
	
	ascent(i in 0..length(curBuildObjects)){
		ReturnToTitleD1(curBuildObjects[i], 10, 6*dir);
	}
	
	if(src == MENU_START_S_PRACTICE){
		if(fblength>0){
			SetAreaCommonData("ScriptBuilderData", "FinalBuild", FinalBuild);
		}
		if(fblength>0 && sCancel < sCanHold){
			let FinalBuildPath = [];
			ascent(i in 0..fblength){
				let fb = FinalBuild[i];
				FinalBuildPath = FinalBuildPath~[DayPaths[fb[0]][fb[1]-1]];
			}
			PlaySound("se_ok00");
			SetAreaCommonData("ScriptBuilderData", "SSP_FinalBuild", FinalBuildPath);
			CharacterSelect(src);
		}else{
			MainMenu(src);
		}
	}else{
		
	}
	
	ssx = sx; //temp
	ssy = sy; //temp
	
	ForceDialogueOff = true;
	sx = -1;
	sy = -1;
	
	RefreshMenu;
	ReturnToTitle(DayComment);
	ReturnToTitle(DayName);
	
	
	function ChangeDay(num){
		dir = -num;
		lx = sx;
		ly = sy;
		sy = 0;
		sx += num;
		selection = 0;
		if(sx < 0){sx = length(DayNames)-1;}
		if(sx > length(DayNames)-1){sx = 0;}
		RedrawMenu(0);
		sh = 12;
	}
	function CreateBuildName(str){
		let curObj = DrawSubMenuText(str);
		ObjText_SetMaxWidth(curObj, 192);
		ObjText_SetHorizontalAlignment(curObj, ALIGNMENT_CENTER);
		ObjText_SetFontSize(curObj,SkipPix);
		ObjRender_SetColor(curObj, 128, 192, 255);
		ObjRender_SetPosition(curObj, lCord[0]+128-96, lCord[1]-128+SkipPix*length(curBuildObjects), 0);
		EnterFromTitleD1(curObj, 20, 5);
		curBuildObjects = curBuildObjects~[curObj];
	}
	function RedrawMenu(type){
		//DrawNewCutin;
		RefreshMenu;
		curDayScenes = preScene~DayNames[sx];
		CreateDayName;
		DrawNewScenes(type);
	}
	task DrawNewScenes(type){
		let locsx = sx;
		let curObj = ID_INVALID;
		
		if(length(preScene)>0){
			curObj = DrawSubMenuText(curDayScenes[0]);
			ObjText_SetFontSize(curObj,SkipPix*1.5);
			ObjRender_SetPosition(curObj, lCord[0]-32+22.55*(0-dir), lCord[1]-96-SkipPix*0.5, 0);
			EnterFromTitleD1(curObj, 12, 5*dir);
			GrantMouseProperties(curObj, 0, [192, SkipPix*1.5], 1.1);
			curTextObjects = curTextObjects~[curObj];
		}
		
		ascent(i in length(preScene)..length(curDayScenes)){
			if(locsx != sx){break;}
			curObj = DrawSubMenuText(curDayScenes[i]);
			
			if(DayAvailable[sx][i-ps]==0){
				ObjText_SetText(curObj,"???????");
			}
			ObjText_SetFontSize(curObj,SkipPix);
			curTextObjects = curTextObjects~[curObj];
			ObjRender_SetColor(curObj, 128, 128, 128);
			ObjRender_SetPosition(curObj, lCord[0]-32+22.55*(0-dir), lCord[1]-96+SkipPix*i, 0);
			GrantMouseProperties(curObj, i, [192, SkipPix], 1.1);
			EnterFromTitleD1(curObj, 12, 5*dir);
			if(type == 0){yield;}
		}
	}
	task RefreshMenu{
		ascent(i in 0..length(curTextObjects)){
			ReturnToTitleD1(curTextObjects[i], 10, 6*dir);
		}
		ReturnToTitleD1(DayName, 12, 8*dir);
		curTextObjects = [];
	}
	task CreateDayName{
		DayName = DrawSubMenuText("Day "~IntToString(sx+1));
		Obj_Delete(DayName); //temp
		ObjText_SetHorizontalAlignment(DayName, ALIGNMENT_LEFT);
		ObjRender_SetPosition(DayName, lCord[0]-16+33.58*(0-dir), lCord[1]-160, 0);
		ObjText_SetMaxWidth(DayName, 320);
		ObjText_SetFontSize(DayName,28*Font_Sub_Modifier);
		
		EnterFromTitleD1(DayName, 15, 6*dir);
		//multiplier is 2.2386666666 maybe, at least for 15 frames it is
	}
	
	
	
	task DrawNewCutin{
		ForceDialogueOff = true;
		//ReturnToTitle(DayComment);
		yield;
		ForceDialogueOff = false;
		
		
		if(sy != -1+ps){
			if(!IsSelectionAvailable){
				let timg = current~"source/Menu/previews/Undefined.png";
				ShowBossImage(timg, 800, 300, 640-GetTextureWidth(timg)/2, 240);
				CreateDialogue("(SD2)Locked boss");
			}else{
				CreateDialogue(DayComments[sx][0]); //TEMP only for this package
				/*DayComment = DrawSubMenuText(DayComments[sx][sy-1]);
				ObjText_SetHorizontalAlignment(DayComment, ALIGNMENT_CENTER);
				ObjRender_SetPosition(DayComment, 0, GetScreenHeight/3*2+16, 0);
				ObjText_SetMaxWidth(DayComment, GetScreenWidth);
				ObjText_SetFontSize(DayComment,14*Font_Sub_Modifier);
				ObjText_SetLinePitch(DayComment, -2);
				
				EnterFromTitle(DayComment);
				*/
				let TargetArray = DayImages[sx][sy-ps];
				
				TargetArray = [current~"source/Menu/previews/"~IntToString(sx)~".png"];
				
				if(length(TargetArray) == 1){
					let timg = TargetArray[0];
					ShowBossImage(timg, 800, 300, 640-GetTextureWidth(timg)/2, 240);
				}else if(length(TargetArray) == 2){
					let lx = 640;
					let timg1 = TargetArray[0];
					let timg2 = TargetArray[1];
					
					lx-=GetTextureWidth(timg2)/3;
					ShowBossImage(timg2, 800, 180, lx, 240);
					
					lx-=GetTextureWidth(timg1)/2;
					ShowBossImage(timg1, 800, 300, lx, 240);
				}else if(length(TargetArray)==3){
					//oh jeez this is not elegant at all
					let TotalSize = 0;
					let MainImgHeight = GetTextureHeight(TargetArray[0]);
					ascent(i in 1..3){
						let timg = TargetArray[i];
						TotalSize += GetTextureWidth(timg)/2;
					}
					let CenterX = 640-TotalSize/2;
					descent(i in 1..3){
						let timg = TargetArray[i];
						let nang = -90+360/3*i;
						let sx = CenterX+300*cos(nang);
						let sy = 240-MainImgHeight*0.75+300*sin(nang);
						
						let ex = 640-TotalSize+TotalSize/6;
						if(i == 1){ex = 640-TotalSize/6;}
						
						ShowBossImage(timg, sx, sy, ex, 240-MainImgHeight*0.15);
					}
					ShowBossImage(TargetArray[0], CenterX, 500, CenterX, 240+MainImgHeight*0.1);
				}else{
					let llen = length(TargetArray);
					descent(i in 0..llen){
						let timg = TargetArray[i];
						let ndist = GetScreenWidth/3+(GetScreenWidth/3*2/llen)/2+GetScreenWidth/3*2/llen*i;
						let mod = 1;
						if(i%2==0){mod = -1;}
						ShowBossImage(timg, ndist, GetScreenHeight/2+GetScreenHeight*0.6*mod,
							ndist, GetScreenHeight/2);
							WriteLog(GetScreenHeight*mod);
					}
					descent(i in 0..length(TargetArray)){
						//ShowBossImage(TargetArray[i], 384+64*i, 640, 360+64*i, 240);
					}
				}
				if(src==MENU_START_S_PRACTICE){
					CreateDialogue(DayComments[sx][sy-1]);
				}
			}
		}
	}
	
	function CreateDialogue(str){
		yield;yield;
		ForceDialogueOff = false;
		//WriteLog(DayComments[sx][sy-1]);
		CreateDialogueFromString(24, GetScreenHeight/4*3-16-20, [str]);
	}
	
	task ShowBossImage(img, x, y, ex, ey){
		// path, id, title, text, image, replay name
		
		let fx = sx;
		let fy = sy;
		
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		let localalpha = 30;
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.74);
		ObjPrim_SetTexture(obj, img);
		ObjSprite2D_SetSourceRect(obj, 0, 0, GetTextureWidth(img)-1, GetTextureHeight(img)-1);
		ObjSprite2D_SetDestCenter(obj);
		ObjRender_SetPosition(obj, x, y, 0);
		ObjRender_SetAlpha(obj, 0);
		
		let dist = 0;
		let ang = 0;
		let tx = ex;
		let ty = ey;
		
		let rang = rand(0, 360);
		
		
		//let xm = spd*cos(ang);
		//let ym = spd*sin(ang);
		
		let len = 25;
		let outlen = 10;
		
		
		descent(i in 0..len){
			//if(!(fx==sx && fy==sy)){break;} temp comment just to make it work for this package
			if(!(fx==sx)){break;} // this is temp too
			localalpha = 30+225-225/len*i;
			yield;
			DoActions;
		}
		
		//while(fx==sx && fy==sy){ same here
		while(fx==sx){ // this is temp too
			yield;
			DoActions;
		}
		
		ascent(i in 0..outlen){
			localalpha = max(0, localalpha-255/outlen*i);
			DoActions;
			yield;
		}
		Obj_Delete(obj);
		
		sub DoActions{
			tx = ex + 6*cos(rang)*sin(rang*0.18);
			ty = ey + 6*sin(rang)*cos(rang*0.25);
			rang ++;
			dist = GetDistance(x, y, tx, ty)/13;
			ang = AngleToLocation(x, y, tx, ty);
			x += dist*cos(ang);
			y += dist*sin(ang);
			ObjRender_SetPosition(obj, (x), (y), 0);
			ObjRender_SetAlpha(obj, localalpha);
		}
	}

	sub Control_PracticeMenu{
		if(CheckForMenuAction("Confirm")){
			if(sy == 0){
				break;
			}
			if(fblength < 10){
				PlaySound("se_ok00");
				if(fblength == 9){selection = 0;}
				FinalBuild = FinalBuild~[[sx, sy]];
				CreateBuildName(curDayScenes[sy]);
			}else{
				selection = 0;
				PlaySound("se_invalid00");
			}
		}
		if(!CheckForMenuActionB1("Cancel", KEY_FREE)){
			sCancel++;
			if(sCancel >= sCanHold){break;}
			
			if(CheckForMenuActionB1("Cancel", KEY_PULL)){
				PlaySound("se_cancel00");
				
				if(fblength>0){
					ReturnToTitleD1(curBuildObjects[length(curBuildObjects)-1], 20, 5);
					
					FinalBuild = erase(FinalBuild, fblength-1);
					curBuildObjects = erase(curBuildObjects, length(curBuildObjects)-1);
				}else{
					break;
				}
			}
		}else{sCancel = 0;}
		fblength = length(FinalBuild);
	}
	
	sub Control_StartGameMenu{
		if(CheckForMenuAction("Confirm")){
			PlaySound("se_ok00");
			SetAreaCommonData("ScriptBuilderData", "MG_StartBossInt", sx*(length(DayNames[0])-1)+sy);
			SetAreaCommonData("ScriptBuilderData", "MG_StartBossStr", DayNames[sx][sy]);
			SetAreaCommonData("ScriptBuilderData", "MG_StartBossPath", DayPaths[sx][sy]);
			CharacterSelect(src);
			break;
		}
		if(CheckForMenuAction("Cancel")){
			PlaySound("se_cancel00");
			MainMenu(src);
			break;
		}
	}
	
}


task SpellPractice{
	yield;
	
	selection = -1;
	lastselection = -1;
	selecthold = 16;
	
	let menuselect = 0; //For the scroll effect
	let pdiff = 0; // The local version of sdiff
	//----
	//let DiffNames = ["Easy", "Normal", "Hard", "Lunatic", "Overdrive", "Cirno"];
	let DiffNames = ["All Star"];
	//----
	
	let TextObjects = [];
	let TextAlphas = [];
	let Cord = [32, 196];
	
	ascent(i in 0..length(ScriptNames[pdiff])){
		TextObjects = TextObjects~[DrawSubMenuText(ScriptNames[pdiff][i][0])];
		TextAlphas = TextAlphas~[0];
	}
	
	let FinalBuild = [];
	let CurBuildNum = [];
	let ArrayCount = 0;
	
	
	
	let BuildText = DrawSubMenuText("Current Attack IDs:");
	ObjText_SetHorizontalAlignment(BuildText, ALIGNMENT_CENTER);
	ObjRender_SetPosition(BuildText, 0, Cord[1]-160, 0);
	ObjText_SetMaxWidth(BuildText, 640);
	ObjText_SetFontSize(BuildText,14*Font_Sub_Modifier);
	
	let BuildNumText = DrawSubMenuText("{None}");
	ObjText_SetHorizontalAlignment(BuildNumText, ALIGNMENT_CENTER);
	ObjRender_SetPosition(BuildNumText, 160, Cord[1]-144, 0);
	ObjText_SetMaxWidth(BuildNumText, 320);
	Obj_SetVisible(BuildNumText, true);
	ObjText_SetFontSize(BuildNumText,12*Font_Sub_Modifier);
	
	let StartGame = DrawSubMenuText("Return To Main Menu");
	ObjRender_SetPosition(StartGame, Cord[0], Cord[1]-80, 0);
	ObjText_SetFontSize(StartGame,16*Font_Sub_Modifier);
	ObjText_SetFontBorderColor(StartGame,24,24,24);
	
	let DifficultyText = DrawSubMenuText(DiffNames[0]);
	let DiffAlpha = 0;
	ObjText_SetHorizontalAlignment(DifficultyText, ALIGNMENT_LEFT);
	ObjRender_SetPosition(DifficultyText, Cord[0]+320, Cord[1]-84, 0);
	ObjText_SetMaxWidth(DifficultyText, 120);
	ObjText_SetFontSize(DifficultyText,24*Font_Sub_Modifier);
	Obj_Delete(DifficultyText); //all star
	
	let PatternText = DrawSubMenuText("Pattern Comment");
	ObjText_SetHorizontalAlignment(PatternText, ALIGNMENT_CENTER);
	ObjRender_SetPosition(PatternText, 0, Cord[1]+172, 0);
	ObjText_SetMaxWidth(PatternText, 640);
	ObjText_SetFontSize(PatternText,16*Font_Sub_Modifier);
	
	let CommentText = DrawSubMenuText(DiffNames[0]);
	let CommentAlpha = 0;
	ObjText_SetHorizontalAlignment(CommentText, ALIGNMENT_CENTER);
	ObjRender_SetPosition(CommentText, 40, Cord[1]+192, 0);
	ObjText_SetMaxWidth(CommentText, 560);
	ObjText_SetFontSize(CommentText,12*Font_Sub_Modifier);
	
	EnterFromTitle(BuildText);
	EnterFromTitle(StartGame);
	EnterFromTitle(BuildNumText);
	EnterFromTitle(DifficultyText);
	EnterFromTitle(PatternText);
	EnterFromTitle(CommentText);
	UpdateCommentText;
	loop{
		if(ArrayCount>0){
			ObjText_SetText(StartGame,"Start Game");
			let bts = "";
			ascent(i in 0..length(CurBuildNum)){
				bts = bts~CurBuildNum[i];
				if(i != length(CurBuildNum)-1){
					bts = bts ~ ", ";
				}
			}
			ObjText_SetText(BuildNumText,bts);
		}else{
			ObjText_SetText(StartGame,"Return To Main Menu");
			ObjText_SetText(BuildNumText,"{None}");
		}
		ascent(i in 0..length(TextObjects)){
			ObjRender_SetAlpha(TextObjects[i], TextAlphas[i]);
			TextAlphas[i] = min(TextAlphas[i]+10, 255);
			ObjRender_SetPosition(TextObjects[i], Cord[0], Cord[1]-32+(i-menuselect)*12, 0);
			Obj_SetVisible(TextObjects[i], true);
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else{
				ObjRender_SetColor(TextObjects[i], 128, 128, 128);
				if(i-menuselect<0||i-menuselect>15){
					Obj_SetVisible(TextObjects[i], false);
				}
			}
		}
		ObjRender_SetAlpha(DifficultyText, DiffAlpha);
		DiffAlpha = min(DiffAlpha+10, 255);
		ObjRender_SetAlpha(CommentText, CommentAlpha);
		CommentAlpha = min(CommentAlpha+15, 255);
		
		if(selection==-1){
			ObjRender_SetColor(StartGame, 255, 255, 255);
		}else{
			ObjRender_SetColor(StartGame, 128, 128, 128);
		}
		
		if(GetVirtualKeyState(VK_UP)!=KEY_FREE&&GetVirtualKeyState(VK_DOWN)==KEY_FREE){
			if(GetVirtualKeyState(VK_UP) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_UP) == KEY_PUSH || selecthold == 0){
				MenuMove(-1);
				PlaySound("se_select00");
				if(selection-menuselect<0&&menuselect>0){
					menuselect--;
				}
				if(selection<-1){
					selection = length(TextObjects)-1;
					menuselect = length(TextObjects)-min(length(TextObjects), 16);
				}
				UpdateCommentText;
			}
			selecthold--;
		}else
		if(GetVirtualKeyState(VK_DOWN)!=KEY_FREE){
			if(GetVirtualKeyState(VK_DOWN) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_DOWN) == KEY_PUSH || selecthold == 0){
				MenuMove(1);
				PlaySound("se_select00");
				if(selection>length(TextObjects)-1){
					selection = -1;
					menuselect = 0;
				}
				if(selection-menuselect>15){
					menuselect++;
				}
				UpdateCommentText;
			}
			selecthold--;
		}else{selecthold = 16;}
		/*
		if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){
			pdiff--;
			if(pdiff < 0){pdiff = 5;}
			ChangeDiff;
			UpdateCommentText;
		}
		if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){
			pdiff++;
			if(pdiff > 5){pdiff = 0;}
			ChangeDiff;
			UpdateCommentText;
		}
		*/
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			if(selection == -1){
				break;
			}
			if(ArrayCount <= 36){
				FinalBuild = FinalBuild~[[ScriptIDs[selection]]];
				CurBuildNum = CurBuildNum~[rtos("000", selection+1)];
				ArrayCount++;
				PlaySound("se_ok00");
			}else{
				PlaySound("se_invalid");
			}
		}
		if(GetVirtualKeyState(VK_SPELL)==KEY_PUSH){
			if(selection==-1){
				if(ArrayCount<=0){
					break;
				}
				ArrayCount--;
				//Not sure why but if I don't do it like this it errors into a type change error
				//despite doing exactly what i was doing before why
				if(length(FinalBuild)==1){
					FinalBuild = [];
					CurBuildNum = [];
				}else{
					FinalBuild = erase(FinalBuild, length(FinalBuild)-1);
					CurBuildNum = erase(CurBuildNum, length(CurBuildNum)-1);
				}
			}
			lastselection = selection;
			selection = -1;
			menuselect = 0;
			PlaySound("se_cancel00");
			if(lastselection!= -1){UpdateCommentText;}
		}
		yield;
	}
	ascent(i in 0..length(TextObjects)){
		ReturnToTitle(TextObjects[i]);
	}
	ReturnToTitle(StartGame);
	ReturnToTitle(BuildText);
	ReturnToTitle(CommentText);
	ReturnToTitle(PatternText);
	ReturnToTitle(BuildNumText);
	ReturnToTitle(DifficultyText);
	
	
	selection = -10;
	yield;
	if(ArrayCount <= 0){MainMenu(MENU_START_S_PRACTICE);}else{CharacterSelect(MENU_START_S_PRACTICE);}
	
	
	//Uncomment these to undo these
	//ScriptNames = [[]];
	//ScriptIDs = [];

	if(length(FinalBuild)>0){
		PlaySound("se_ok00");
		SetAreaCommonData("ScriptBuilderData", "SP_FinalBuild", FinalBuild);
	}else{
		PlaySound("se_cancel00");
	}
	//-------------------------------------------------------
	sub UpdateCommentText{
		CommentAlpha = 0;
		ObjRender_SetAlpha(CommentText, 0);
		
		if(selection == -1){
			FadeObjectA1(PatternText, 0, 15);
			ObjText_SetText(PatternText, "Instructions");
			ObjText_SetText(CommentText, "
In this spell practice menu, you are allowed to \"build\" a session by choosing[r]
which attack patterns you want to face. You may choose up to a maximum of [r]
40 different attacks in one session. To change the difficulty, press the left[r]
and right arrow keys. Press the select button on the spellcard to add it to the[r]
list, and press the cancel button to remove the last attack pattern.");
		}else{
			let TargetArray = ScriptPreviews[selection];
			
			if(length(TargetArray) == 1){
				let timg = TargetArray[0];
				ShowBossImage(selection, timg, 800, 300, 640-GetTextureWidth(timg)/2, 240, 0);
			}else if(length(TargetArray) == 2){
				let lx = 640;
				let timg1 = TargetArray[0];
				let timg2 = TargetArray[1];
				
				lx-=GetTextureWidth(timg2)/3;
				ShowBossImage(selection, timg2, 800, 180, lx, 240, 1);
				
				lx-=GetTextureWidth(timg1)/2;
				ShowBossImage(selection, timg1, 800, 300, lx, 240, 0);
			}else if(length(TargetArray)==3){
				//oh jeez this is not elegant at all
				let TotalSize = 0;
				let MainImgHeight = GetTextureHeight(TargetArray[0]);
				ascent(i in 1..3){
					let timg = TargetArray[i];
					TotalSize += GetTextureWidth(timg)/2;
				}
				let CenterX = 640-TotalSize/2;
				descent(i in 1..3){
					let timg = TargetArray[i];
					let nang = -90+360/3*i;
					let sx = CenterX+300*cos(nang);
					let sy = 240-MainImgHeight*0.75+300*sin(nang);
					
					let ex = 640-TotalSize+TotalSize/6;
					if(i == 1){ex = 640-TotalSize/6;}
					
					ShowBossImage(selection, timg, sx, sy, ex, 240-MainImgHeight*0.15, i);
				}
				ShowBossImage(selection, TargetArray[0], CenterX, 500, CenterX, 240+MainImgHeight*0.1, 0);
			}else{
				let llen = length(TargetArray);
				descent(i in 0..llen){
					let timg = TargetArray[i];
					let ndist = GetScreenWidth/3+(GetScreenWidth/3*2/llen)/2+GetScreenWidth/3*2/llen*i;
					let mod = 1;
					if(i%2==1){mod = -mod;}
					ShowBossImage(selection, timg, ndist, GetStgFrameHeight/2+(GetStgFrameHeight*1.35)*mod,
						ndist, GetScreenWidth/2, i);
				}
				descent(i in 0..length(TargetArray)){
					ShowBossImage(selection, TargetArray[i], 384+64*i, 640, 360+64*i, 240, i);
				}
			}
			if(lastselection == -1){FadeObjectA1(PatternText, 0, 15);ObjText_SetText(PatternText, "Pattern Comment")}
			ObjText_SetText(CommentText, ScriptNames[pdiff][selection][1]);
		}
	}
	
	function ChangeDiff{
			FinalBuild = [];
			CurBuildNum = [];
			ArrayCount = 0;
			PlaySound("se_ok00");
			RedrawText;
	}
	
	task RedrawText{
		DiffAlpha = 0;
		ascent(i in 0..length(TextAlphas)){
			TextAlphas[i] = 0;
		}
		yield;
		ObjText_SetText(DifficultyText,DiffNames[pdiff]);
		ascent(i in 0..length(TextObjects)){ObjText_SetText(TextObjects[i],ScriptNames[pdiff][i][0]);}
	}


	task ShowBossImage(select, img, x, y, ex, ey, i){
		// path, id, title, text, image, replay name
		
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		let localalpha = 30;
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.74);
		ObjPrim_SetTexture(obj, img);
		ObjSprite2D_SetSourceRect(obj, 0, 0, GetTextureWidth(img)-1, GetTextureHeight(img)-1);
		ObjSprite2D_SetDestCenter(obj);
		ObjRender_SetPosition(obj, x, y, 0);
		ObjRender_SetAlpha(obj, 0);
		
		let dist = 0;
		let ang = 0;
		let tx = ex;
		let ty = ey;
		
		let rang = rand(0, 360);
		
		
		//let xm = spd*cos(ang);
		//let ym = spd*sin(ang);
		
		let len = 25;
		let outlen = 15;
		
		
		descent(i in 0..len){
			if(selection!=select){break;}
			localalpha = 30+225-225/len*i;
			yield;
			DoActions;
		}
		
		while(selection==select){
			yield;
			DoActions;
		}
		
		ascent(i in 0..outlen){
			localalpha = max(0, localalpha-255/outlen*i);
			DoActions;
			yield;
		}
		Obj_Delete(obj);
		
		sub DoActions{
			tx = ex + 6*cos(rang)*sin(rang*0.18);
			ty = ey + 6*sin(rang)*cos(rang*0.25);
			rang ++;
			dist = GetDistance(x, y, tx, ty)/13;
			ang = AngleToLocation(x, y, tx, ty);
			x += dist*cos(ang);
			y += dist*sin(ang);
			ObjRender_SetPosition(obj, (x), (y), 0);
			ObjRender_SetAlpha(obj, localalpha);
		}
	}


}

task ReplaySceneSelection{
	let rResult = ActivateMenu(ScriptSrc ~ "ExRumia_ReplaySelectScene.txt");
	if(rResult==ID_INVALID){
		MainMenu(MENU_REPLAY);
	}else{
		//StartTheGame just temp because lazy
		StartTheScene(atoi(GetReplayInfo(rResult, REPLAY_COMMENT)), [""], GetReplayInfo(rResult, REPLAY_FILE_PATH));
	}
}

task MusicRoom{
	yield;
	
	selection = 0;
	lastselection = 0;
	selecthold = 16;
	
	let MusicData = [
		[
		"Test Song Title 1",
		"test 1"
		],
		[
		"Test Song Number 2",
		"test song number two"
		],
		[
		"Test Song Title 3",
		"test 3"
		],
		
		[
		"Test Song Number 4",
		"test song number four"
		],
	];
	
	let TextObjects = [];
	let TextAlphas = [];
	let Cord = [72, 180];
	
	
	ascent(i in 0..length(MusicData)){
		TextObjects = TextObjects~[DrawSubMenuText(MusicData[i][0])];
		ObjText_SetFontSize(TextObjects[i],18*Font_Sub_Modifier);
		ObjRender_SetPosition(TextObjects[i], Cord[0], Cord[1]-32+(i)*18, 0);
		TextAlphas = TextAlphas~[(i+1.35)*48];
	}
	
	let CommentAlpha = 0;
	
	let CommentTitle = DrawSubMenuText("");
	ObjText_SetHorizontalAlignment(CommentTitle, ALIGNMENT_LEFT);
	ObjRender_SetPosition(CommentTitle, 48, Cord[1]+172, 0);
	ObjText_SetMaxWidth(CommentTitle, 640);
	ObjText_SetFontSize(CommentTitle,20*Font_Sub_Modifier);
	
	let CommentText = DrawSubMenuText("");
	ObjText_SetHorizontalAlignment(CommentText, ALIGNMENT_LEFT);
	ObjRender_SetPosition(CommentText, 80, Cord[1]+200, 0);
	ObjText_SetMaxWidth(CommentText, 480);
	ObjText_SetFontSize(CommentText,14*Font_Sub_Modifier);
	
	EnterFromTitle(CommentTitle);
	EnterFromTitle(CommentText);
	
	loop{
		ascent(i in 0..length(TextObjects)){
			ObjRender_SetAlpha(TextObjects[i], max(0, TextAlphas[i]));
			TextAlphas[i] = min(TextAlphas[i]+12, 255);
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else{
				ObjRender_SetColor(TextObjects[i], 128, 128, 128);
			}
		}
		ObjRender_SetAlpha(CommentTitle, CommentAlpha);
		ObjRender_SetAlpha(CommentText, CommentAlpha);
		CommentAlpha = min(CommentAlpha+15, 255);
		
		if(GetVirtualKeyState(VK_UP)!=KEY_FREE&&GetVirtualKeyState(VK_DOWN)==KEY_FREE){
			if(GetVirtualKeyState(VK_UP) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_UP) == KEY_PUSH || selecthold == 0){
				MenuMove(-1);selecthold+=3;
				PlaySound("se_select00");
				if(selection<0){
					selection = length(TextObjects)-1;
				}
			}
			selecthold--;
		}else
		if(GetVirtualKeyState(VK_DOWN)!=KEY_FREE){
			if(GetVirtualKeyState(VK_DOWN) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_DOWN) == KEY_PUSH || selecthold == 0){
				MenuMove(1);selecthold+=3;
				PlaySound("se_select00");
				if(selection>length(TextObjects)-1){
					selection = 0;
				}
			}
			selecthold--;
		}else{selecthold = 16;}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			ObjRender_SetAlpha(CommentTitle, 0);
			ObjRender_SetAlpha(CommentText, 0);
			CommentAlpha = 0;
			ObjText_SetText(CommentTitle,MusicData[selection][0]);
			ObjText_SetText(CommentText,MusicData[selection][1]);
			PlaySound("se_ok00");
			PlayMusic(rtos("00", selection), true);
		}
		if(GetVirtualKeyState(VK_SPELL)==KEY_PUSH){
			PlaySound("se_cancel00");
			break;
		}
		yield;
	}
	ascent(i in 0..length(TextObjects)){
		ReturnToTitle(TextObjects[i]);
	}
	ReturnToTitle(CommentText);
	ReturnToTitle(CommentTitle);
	PlayMusic("00", false);
	MainMenu(MENU_MUSICROOM);
}

task SetOptionsMenu{
	yield;
	
	let selection = 0;
	let selecthold = -16;
	let selectinc = 0;
	
	let selectlife = [1, 1];
	if(options[3] == -1){selectlife[0]=0;options[3] = 2;}
	if(options[4] == -1){selectlife[1]=0;options[4] = 2;}
	
	
	
	
	let locked = false;
	let Cord = [176, 320];
	
	let TextObjects = [];
	let QualObjects = [];
	let LBarObjects = [];
	//let InviObjects = [];
	let LifeObjects = [ID_INVALID, ID_INVALID];
	let BombObjects = [ID_INVALID, ID_INVALID];
		LifeObjects[0] = DrawSubMenuText("Default");
		ObjRender_SetPosition(LifeObjects[0], Cord[0]+112, Cord[1]-10, 0);
		SetDefaultTextProp(LifeObjects[0]);
		
		LifeObjects[1] = DrawSubMenuText("<< "~rtos("00", options[3])~" >>");
		ObjRender_SetPosition(LifeObjects[1], Cord[1]+112, Cord[1]-10, 0);
		SetDefaultTextProp(LifeObjects[1]);
		
		BombObjects[0] = DrawSubMenuText("Default");
		ObjRender_SetPosition(BombObjects[0], Cord[0]+112, Cord[1]+25, 0);
		SetDefaultTextProp(BombObjects[0]);
		
		BombObjects[1] = DrawSubMenuText("<< "~rtos("00", options[4])~" >>");
		ObjRender_SetPosition(BombObjects[1], Cord[1]+112, Cord[1]+25, 0);
		SetDefaultTextProp(BombObjects[1]);
		
	let TextNames = ["Volume BGM", "Volume SE", "Effects Quality", "Lifebar Type",
					// "Use Mouse", 
					"Set Initial Lives", "Set Initial Bombs", 
//					"Invinicbility Time", 
//					"Loading Character Info",
					"Return To Main Menu"];
					
	let Details = [
				"Sets the volume of the Background Music.",
				"Sets the volume of game Sound Effects.",
				"Sets the quality and intensity of game effects.",
				"Sets the type of lifebar to use in-game.[r]GFW is the most graphic intensive.",
				// "Enables or disables the use of the mouse in menus.",
				"Cheat! - Sets the starting number of lives.",
				"Cheat! - Sets the number of bombs you respawn and start with.",
				"Cheat! - Sets how long all invincibility is increased by.[r]Normal: 100%; Extend: 175%; Always: Always Invincible.",
//				"Option - Sets when how to load available player information.[r]
//				Initially: Only the first run of the game will load information (might become outdated!)[r]
//				Once: Only the first time you open the player select in one session will load information.[r]
//				Always: Everytime the player screen comes up, it will load the information.",
				"Exits the option menu. Settings will be saved."
	];
	let QualText = ["None", "Low", "Normal", "High"];
	let LifebarText = Lifebars;
	let InviText = ["Normal", "Extend", "Always"];
	let LoadText = ["Once", "Initially", "Always"];
	ascent(i in 0..length(TextNames)){
		TextObjects = TextObjects~[DrawSubMenuText(TextNames[i])];
		let locText = TextObjects[i];
		ObjRender_SetPosition(locText, Cord[0]-90, Cord[1]-150+i*35, 0);
		SetDefaultTextProp(locText);
	}
	ascent(i in 0..length(QualText)){
		QualObjects = QualObjects~[DrawSubMenuText(QualText[i])];
		let locText = QualObjects[i];
		ObjRender_SetPosition(locText, Cord[0]+112+64*i, Cord[1]-80, 0);
		if(i == 2){ObjRender_SetPosition(locText, Cord[0]+112+57*i, Cord[1]-80, 0);}
		SetDefaultTextProp(locText);
	}
	let lbdist = 138+18*(length(LifebarText)-1);
	ascent(i in 0..length(LifebarText)){
		LBarObjects = LBarObjects~[DrawSubMenuText(LifebarText[i])];
		let locText = LBarObjects[i];
		ObjRender_SetPosition(locText, Cord[0]+112+lbdist/(length(LifebarText)-1)*i, Cord[1]-45, 0);
		SetDefaultTextProp(locText);
	}
	/*
	ascent(i in 0..length(InviText)){
		InviObjects = InviObjects~[DrawSubMenuText(InviText[i])];
		let locText = InviObjects[i];
		ObjRender_SetPosition(locText, Cord[0]+112+80*i, Cord[1]+60, 0);
		SetDefaultTextProp(locText);
	}
	*/
	let BGM_bg = CreateBar;
	ObjRender_SetPosition(BGM_bg, Cord[0]+112, Cord[1]-140, 0);
	ObjRender_SetColor(BGM_bg, 64, 64, 64);
	let BGM = CreateBar;
	ObjRender_SetPosition(BGM, Cord[0]+112, Cord[1]-140, 0);
	ObjRender_SetColor(BGM, 112, 112, 112);
	let SE_bg = CreateBar;
	ObjRender_SetPosition(SE_bg, Cord[0]+112, Cord[1]-105, 0);
	ObjRender_SetColor(SE_bg, 64, 64, 64);
	let SE = CreateBar;
	ObjRender_SetPosition(SE, Cord[0]+112, Cord[1]-105, 0);
	ObjRender_SetColor(SE, 112, 112, 112);
	
	loop{
		if(GetVirtualKeyState(VK_UP)==KEY_PUSH&&!locked){selection--;selectinc=0;selecthold = -16;PlaySound("se_select00");}
		if(GetVirtualKeyState(VK_DOWN)==KEY_PUSH&&!locked){selection++;selectinc=0;selecthold = -16;PlaySound("se_select00");}
		if(selection<0){selection=6}
		if(selection>6){selection=0}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH&&!locked){
			PlaySound("se_ok00");
			if(selection == 6){break;}
		}
		if(GetVirtualKeyState(VK_BOMB)==KEY_PUSH&&!locked){
			PlaySound("se_cancel00");
			if(selection == 6){break;}
			selection = 6;
		}
		
		ObjRender_SetColor(BGM, 112, 112, 112);
		ObjSprite2D_SetDestRect(BGM, 0, -4, (256/100)*options[0], 4);
		ObjRender_SetColor(SE, 112, 112, 112);
		ObjSprite2D_SetDestRect(SE, 0, -4, (256/100)*options[1], 4);
		
		alternative(selection)
		case(0){VolumeControl(0);ObjRender_SetColor(BGM, 224, 224, 224);}
		case(1){VolumeControl(1);ObjRender_SetColor(SE, 224, 224, 224);}
		case(2){QualityControl;}
		case(3){LifebarControl;}
		case(4){LifeBombControl(0);}
		case(5){LifeBombControl(1);}
		//case(6){InvincibilityControl;}
		
		ascent(i in 0..length(TextObjects)){
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else{
				ObjRender_SetColor(TextObjects[i], 128, 128, 128);
			}
		}
		ascent(i in 0..length(QualObjects)){
			let active = 1.5;
			if(selection == 2){active = 1;}
			if(options[2] == i){
				ObjRender_SetColor(QualObjects[i], 255/active, 255/active, 255/active);
			}else{
				ObjRender_SetColor(QualObjects[i], 128/active, 128/active, 128/active);
			}
		}
		ascent(i in 0..length(LBarObjects)){
			let active = 1.5;
			if(selection == 3){active = 1;}
			let n = 255;
			if(options[2] < 2 && i == 0){n = 32;}
			if(options[6] == i){
				ObjRender_SetColor(LBarObjects[i], 255/active, n/active, n/active);
			}else{
				n /= 2;
				ObjRender_SetColor(LBarObjects[i], 128/active, n/active, n/active);
			}
		}
		ascent(i in 0..length(LifeObjects)){
			let active = 1.5;
			if(selection == 4){active = 1;}
			if(selectlife[0] == i){
				ObjRender_SetColor(LifeObjects[i], 255/active, 255/active, 255/active);
			}else{
				ObjRender_SetColor(LifeObjects[i], 128/active, 128/active, 128/active);
			}
		}
		ascent(i in 0..length(BombObjects)){
			let active = 1.5;
			if(selection == 5){active = 1;}
			if(selectlife[1] == i){
				ObjRender_SetColor(BombObjects[i], 255/active, 255/active, 255/active);
			}else{
				ObjRender_SetColor(BombObjects[i], 128/active, 128/active, 128/active);
			}
		}
		/*
		ascent(i in 0..length(InviObjects)){
			let active = 1.5;
			if(selection == 6){active = 1;}
			if(options[5] == i){
				ObjRender_SetColor(InviObjects[i], 255/active, 255/active, 255/active);
			}else{
				ObjRender_SetColor(InviObjects[i], 128/active, 128/active, 128/active);
			}
		}
		*/
		yield;
	}
	
	ascent(i in 0..length(TextObjects)){ReturnToTitle(TextObjects[i]);}
	ascent(i in 0..length(QualObjects)){ReturnToTitle(QualObjects[i]);}
	ascent(i in 0..length(LifeObjects)){ReturnToTitle(LifeObjects[i]);}
	ascent(i in 0..length(BombObjects)){ReturnToTitle(BombObjects[i]);}
	ascent(i in 0..length(LBarObjects)){ReturnToTitle(LBarObjects[i]);}
	//ascent(i in 0..length(InviObjects)){ReturnToTitle(InviObjects[i]);}
	ReturnToTitle(BGM);
	ReturnToTitle(SE);
	ReturnToTitle(BGM_bg);
	ReturnToTitle(SE_bg);
	
	
	if(selectlife[0]==0){options[3] = -1;}
	if(selectlife[1]==0){options[4] = -1;}
	
	SE_VOL = options[1];
	SetCommonData("quality", options[2]);
	SetCommonData("lifebar", Lifebars[options[6]]);
	SaveOptionsAreaData;
	
	MainMenu(MENU_OPTION);
	
	function SetDefaultTextProp(id){
		ObjText_SetMaxWidth(id, 300);
		Obj_SetVisible(id, true);
		ObjText_SetFontSize(id,16*Font_Sub_Modifier);
		ObjText_SetFontBorderColor(id,16,16,16);
	}
	
	function VolumeControl(num){
		let curnum = options[num];
		ObjSound_SetVolumeRate(CurrentBGM, options[0]);
		SE_VOL = options[1];
		ObjSound_SetVolumeRate(CurrentBGM, options[0]);
		if(IsAllKeysFree){selecthold = -16}
		if(GetVirtualKeyState(VK_RIGHT)==KEY_FREE){
			if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH||selecthold>4){
				selecthold = 0;
				options[num] = max(options[num]-1-selectinc, 0);
			}
			if(GetVirtualKeyState(VK_LEFT)==KEY_HOLD){
				selecthold++;
				selectinc+=0.025;
			}else{selecthold = -16;selectinc = 0;}
		}else{
			if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH||selecthold>4){
				selecthold = 0;
				options[num] = min(options[num]+1+selectinc, 100);
			}
			if(GetVirtualKeyState(VK_RIGHT)==KEY_HOLD){
				selecthold++;
				selectinc+=0.025;
			}else{selecthold = -16;selectinc = 0;}
		}
		if(curnum != options[num]){PlaySound("se_select00");}
	}
	function QualityControl{
		if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){options[2]=options[2]+1;PlaySound("se_select00");}
		if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){options[2]=options[2]-1;PlaySound("se_select00");}
		if(options[2]>3){options[2] = 0;}
		if(options[2]<0){options[2] = 3;}
		if(options[2] < 2){if(options[6] == 0){options[6] = 1;}}
	}
	function LifebarControl{
		if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){options[6]=options[6]+1;PlaySound("se_select00");}
		if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){options[6]=options[6]-1;PlaySound("se_select00");}
		let n = 0;
		if(options[2] < 2){n = 1;}
		if(options[6]>length(LBarObjects)-1){options[6] = n;}
		if(options[6]<n){options[6] = length(LBarObjects)-1;}
	}
	function InvincibilityControl{
		if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){options[5]=options[5]+1;PlaySound("se_select00");}
		if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){options[5]=options[5]-1;PlaySound("se_select00");}
		if(options[5]>2){options[5] = 0;}
		if(options[5]<0){options[5] = 2;}
	}
	function LifeBombControl(num){
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH&&selectlife[num]==1){
			PlaySound("se_ok00");
			if(!locked){locked = true;}else{locked = false}
		}
		if(GetVirtualKeyState(VK_SPELL)==KEY_PUSH&&locked){
			PlaySound("se_cancel00");
			selectlife[num] = 0;
			locked = false;
		}
		if(num==0){ObjText_SetText(LifeObjects[1],"<< "~rtos("00", options[num+3])~" >>");}
		if(num==1){ObjText_SetText(BombObjects[1],"<< "~rtos("00", options[num+3])~" >>");}
		if(!locked){
			if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){selectlife[num]=selectlife[num]+1;PlaySound("se_select00");}
			if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){selectlife[num]=selectlife[num]-1;PlaySound("se_select00");}
			if(selectlife[num]>1){selectlife[num] = 0;}
			if(selectlife[num]<0){selectlife[num] = 1;}
		}else{
			if(num==0){ObjText_SetText(LifeObjects[1],"<--  "~rtos("00", options[num+3])~"  -->");}
			if(num==1){ObjText_SetText(BombObjects[1],"<--  "~rtos("00", options[num+3])~"  -->");}
			if(IsAllKeysFree){selecthold = -16}
			if(GetVirtualKeyState(VK_RIGHT)==KEY_FREE){
				if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH||selecthold>4){
					selecthold = 0;
					if(options[num+3]>0&&options[num+3]<100){PlaySound("se_select00");}
					if(num == 0){options[num+3] = max(options[num+3]-1-selectinc, 0);}
					if(num == 1){options[num+3] = max(options[num+3]-1-selectinc, 0);}
				}
				if(GetVirtualKeyState(VK_LEFT)==KEY_HOLD){
					selecthold++;
					selectinc+=0.025;
				}else{selecthold = -16;selectinc = 0;}
			}else{
				if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH||selecthold>4){
					selecthold = 0;
					if(options[num]>0&&options[num+3]<99){PlaySound("se_select00");}
					if(num == 0){options[num+3] = min(options[num+3]+1+selectinc, 99);}
					if(num == 1){options[num+3] = min(options[num+3]+1+selectinc, 99);}
				}
				if(GetVirtualKeyState(VK_RIGHT)==KEY_HOLD){
					selecthold++;
					selectinc+=0.025;
				}else{selecthold = -16;selectinc = 0;}
			}
		}
	}

	
	function CreateBar{
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.75);
		ObjPrim_SetTexture(obj, NULL);
		ObjSprite2D_SetSourceRect(obj, 0, 0, 1, 1);
		ObjSprite2D_SetDestRect(obj, 0, -4, 256, 4);
		return obj;
	}
}

task ManualMenu{
	//this is temporary code
	//not enough time for the ICM contest to flesh this out
	let info = CreateSpriteObject(InfoSource ~ "00.png");
	ObjSprite2D_SetSourceRect(info, 1, 1, 640, 480);
	ObjSprite2D_SetDestCenter(info);
	ObjRender_SetPosition(info, 320, 240, 0);
	EnterFromTitle(info);
	loop(20){yield;} // so it doesn't instantly close
	while(GetVirtualKeyState(VK_SHOT)==KEY_FREE && GetVirtualKeyState(VK_CANCEL)==KEY_FREE){yield;}
	PlaySound("se_ok00");
	ReturnToTitle(info);
	MainMenu(MENU_MANUAL);
}

task EndGame{
	yield;
	Obj_Delete(MenuBG);
	loop(29){yield;}
	ClosePackage;
}


task StartTheGame(type, player, replaypath){
	SetAreaCommonData("GlobalVariables", "UserLives", options[3]);
	SetAreaCommonData("GlobalVariables", "UserBombs", options[4]);
	
	SetAreaCommonData("GlobalVariables", "Quality", options[2]);
	SetAreaCommonData("GlobalVariables", "LifebarType", Lifebars[options[6]]);
	
	ReturnToTitle(TitleBG);
	ReturnToTitle(MenuBG);
	IsStgFieldActive = true;
	yield;
	SetCommonData("CurrentGameType", IntToString(type));
	if(type == 0){RunRegularGame(current~"source/Boss/MainGame.h");}
	if(type == MENU_START_S_PRACTICE){RunRegularGame(current~"source/Boss/Spellpractice.h");}
	
	task RunRegularGame(scriptpath){
		InitializePackageScript(scriptpath, 0, player, replaypath);
		while(IsStgFieldActive){yield;}
		TTransition;
		MainMenu(MENU_RETURN_START_GAME);
	}	
}

task StartTheScene(type, player, replaypath){

	let lifebomb = options[3..5];
	
	if(lifebomb[0] == -1){lifebomb[0] = 0;}
	if(lifebomb[1] == -1){lifebomb[1] = 0;}

	SetAreaCommonData("GlobalVariables", "UserLives", lifebomb[0]);
	SetAreaCommonData("GlobalVariables", "UserBombs", lifebomb[1]);
	
	SetAreaCommonData("GlobalVariables", "Quality", options[2]);
	SetAreaCommonData("GlobalVariables", "LifebarType", Lifebars[options[6]]);
	
	Obj_Delete(TitleBG);
	Obj_Delete(MenuBG);
	IsStgFieldActive = true;
	yield;
	DestroyLastInstance = false;
	
	SetCommonData("CurrentGameType", IntToString(MENU_START_GAME_SKIP_DIFFICULTY));
	
	
	loop(30){yield;}
	
		SetAreaCommonData("Score", "IsLastSceneInDay", true);
		RunRegularGame(current~"source/Boss/Yuugi/Plural.txt");
		return; 
		
	if(ssy == 0){
		RunRegularGame(DayPaths[ssx][ssy]);
	}else{
		SetAreaCommonData("ScriptBuilderData", "MG_StartBossPath", DayPaths[ssx][ssy]);
		RunRegularGame(current~"source/Boss/Yuugi/SceneSelect.h");
	}
	if(ssy == length(DayPaths[ssx])-1){
		SetAreaCommonData("Score", "IsLastSceneInDay", true);
	}else{
		SetAreaCommonData("Score", "IsLastSceneInDay", false);
	}
	
	
	task RunRegularGame(scriptpath){
		InitializePackageScript(scriptpath, 0, player, replaypath);
		
		while(IsStgFieldActive&&!DestroyLastInstance){yield;}
		if(DestroyLastInstance){return;}
		WriteLog("Menu Escape Start");
		TTransition;
		FallingLeafContainer;
		TitleBG = CreateMenuImage(Menu_Title);
		MenuBG = CreateMenuImage(Menu_Sub);
		PlayMusic("00", true);
		// StartGame_SceneSelect(MENU_START_GAME_SKIP_DIFFICULTY, 1);
		RegisterGameFunc(type);
	}	
}

task QuickLaunch(path, player){
	IsStgFieldActive = true;
	yield;
	

	InitializePackageScript(path, 0, player, "");
	while(IsStgFieldActive){yield;}
	MainMenu(MENU_RETURN_START_GAME);
}

task InitializePackageScript(path, stageindex, player, replaypath){
	yield;
	PlayLoadingAnimationB1("");
	TTransition;
	let pobj = ID_INVALID;
	let NaturalEnd = true;
	let pResult = ID_INVALID;
	SetAreaCommonData("OptionConfig", "OptionValues", options);
	InitializeStageScene;
	if(replaypath!=""){
		SetStageReplayFile(replaypath);
	}else{
		SetStagePlayerScript(player[0]);
	}
		WriteLog("yes");
	SetStageIndex(stageindex);
		WriteLog(path);
	SetStageMainScript(path);
	StartStageScene;
	
	
	while(GetStageSceneState != STAGE_STATE_FINISHED && NaturalEnd){
		if(GetVirtualKeyState(VK_PAUSE) == KEY_PUSH){
			PauseMenuImage;
			PauseStageScene(true);
			pResult = ActivateMenu(ScriptSrc ~ "S_Pause.txt");
			CheckResult;
			PauseStageScene(false);
		}
		if(GetKeyState(KEY_BACK)&&DEBUG){
			TerminateStageScene;
			InitializeStageScene;
			SetStageIndex(stageindex);
			SetStageMainScript(path);
			SetStagePlayerScript(player[0]);
			StartStageScene;
		}
		yield;
	}
	
	if(NaturalEnd){
		PauseMenuImage;
		if(!IsReplay){
			FinalizeStageScene;
			pResult = ActivateMenu(ScriptSrc ~ "S_EndScene.txt");
			CheckResult;
		}else{
			TerminateStageScene;
			FinalizeStageScene;
			IsStgFieldActive = false;
		}
	}
	Obj_Delete(pobj);
	
	
	sub CheckResult{
		Obj_Delete(pobj);
		alternative(pResult)
		case(RESULT_CANCEL){}
		case(RESULT_END){
			NaturalEnd = false;
			TerminateStageScene;
			IsStgFieldActive = false;
		}
		case(RESULT_SAVE_REPLAY){ // this can only occur in EndScene
			DoSaveReplay;
		}
		case(RESULT_RETRY){
			NaturalEnd = false;
			TerminateStageScene;
			InitializePackageScript(path, stageindex, player, replaypath);
			return;
		}
		case(20){ // RESULT_SAVE_REPLAY_FROM_PAUSE this can only occur in Pause
			NaturalEnd = false;
			TerminateStageScene;
			FinalizeStageScene;
			DoSaveReplay;
		}
		case(21){ // RESULT_CONTINUE_NEXT_SCENE this can only occur in EndScene
			NaturalEnd = false;
			TerminateStageScene;
			ssy++;
			DestroyLastInstance = true;
			StartTheScene(GetCommonData("CurrentGameType", "0"), player, replaypath);
			return;
		}
		others{	
			RaiseError("Something happened. Report this error number to gtbot: Result " ~ IntToString(pResult));
		}
	}
	
	task PauseMenuImage{
		let textureName = GetTransitionRenderTargetName;
		RenderToTextureA1(textureName, 0, 100, true);
		let target = GetTransitionRenderTargetName;
		pobj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjPrim_SetTexture(pobj, target);
		Obj_SetRenderPriority(pobj, 0.1);
		ObjSprite2D_SetSourceRect(pobj, 0, 0, 640, 480);
		ObjSprite2D_SetDestCenter(pobj);
		ObjRender_SetPosition(pobj, 320, 240, 0);
		ObjRender_SetAlpha(pobj, 128);
	}
	
}

function ActivateMenu(spath){
	let obj = LoadScript(spath);
	StartScript(obj);
	while(!IsCloseScript(obj)){yield;}
	return GetScriptResult(obj);
}
	
function DoSaveReplay{
	ActivateMenu(ScriptSrc ~ "S_ReplaySaveScene.txt");
	IsStgFieldActive = false;
}



task TTransition{
	
	let textureName = GetTransitionRenderTargetName;
	RenderToTextureA1(textureName, 0, 100, true);
	
	

	let objImage = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(objImage, 100);
	ObjPrim_SetTexture(objImage, textureName);
	ObjSprite2D_SetSourceRect(objImage, 0, 0, 640, 480);
	ObjSprite2D_SetDestRect(objImage, 0, 0, 640, 480);

	let alpha = 255;
	while(alpha > 0){
		ObjRender_SetAlpha(objImage, alpha);
		alpha -= 16;
		yield;
	}
	Obj_Delete(objImage);
}



function CreateSpellChoice(owner, path, name, comment, preview){
	let id = length(ScriptIDs)+1;	
	
	ascent(i in 0..length(name)){
		ScriptNames[i] = ScriptNames[i] ~ [[rtos("000", id)~" - ("~owner~") "~name[i], comment[i]]];
	}
	
	ScriptIDs = ScriptIDs~[path];
	
	ScriptPreviews = ScriptPreviews~preview;
}


function MovePlayerCursor(allow, max, shold, sspeed){
	let loclastsec = selection;
	if(GetVirtualKeyState(VK_UP)!=KEY_FREE&&GetVirtualKeyState(VK_DOWN)==KEY_FREE){
		if(GetVirtualKeyState(VK_UP) != KEY_HOLD){
			selecthold = shold;
		}
		if(GetVirtualKeyState(VK_UP) == KEY_PUSH || selecthold == 0){
			PlaySound("se_select00");
			IncreaseSel(-1);
			if(selection<0){
				selection = max;
			}
		}
		selecthold--;
	}else if(GetVirtualKeyState(VK_DOWN)!=KEY_FREE){
		if(GetVirtualKeyState(VK_DOWN) != KEY_HOLD){
			selecthold = shold;
		}
		if(GetVirtualKeyState(VK_DOWN) == KEY_PUSH || selecthold == 0){
			PlaySound("se_select00");
			IncreaseSel(1);
			if(selection>max){
				selection = 0;
			}
		}
		selecthold--;
	}else{selecthold = shold;}
	lastselection = loclastsec;
	return loclastsec-selection;
	
	function IncreaseSel(num){
		selection+=num;
		selecthold += sspeed;
		if(allow[0] == -1){return;}
		while(selection > 0 && selection < max){
			if(!allow[selection]){
				selection+=num;
			}else{break;}
		}
	}
}

task GrantMouseProperties(aobj, selectx, boundary, sizemod){
	return; //for now
	let tx = ObjRender_GetX(aobj);
	let ty = ObjRender_GetY(aobj);
	
	let w = boundary[0];
	let h = boundary[1];
	
	
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.74);
	ObjPrim_SetTexture(obj, NULL);
	ObjSprite2D_SetSourceRect(obj, 48, 416, 176, 464);
	// ObjSprite2D_SetDestRect(obj, -w/2, -h/2, w/2, h/2);
	ObjSprite2D_SetDestRect(obj, 0, 0, w, h);
	// ObjSprite2D_SetDestRect(obj, 0, -h/2, w, h/2);
	ObjRender_SetAlpha(obj, 128);
	ObjRender_SetPosition(obj, tx, ty, 0);
	
	
	
	while(!Obj_IsDeleted(aobj)){
	
		if(IsMouseActive){
			ObjRender_SetAlpha(obj, 128);
		}else{
			ObjRender_SetAlpha(obj, 0);
		}
		
		if(CheckInsideBoxA2(GetMouseX, GetMouseY, tx, ty, w, h) && selectx != selection){
			IsMouseActive = true;
			selection = selectx;
		}
		
		yield;
	}
	Obj_Delete(obj);
}

function CheckInsideBoxA1(tx, ty, bx, by, w, h){
	let rw = w/2;
	let rh = h/2;
	if(tx < bx-rw){return false;}
	if(tx > bx+rw){return false;}
	if(ty < by-rh){return false;}
	if(ty > by+rh){return false;}
	return true;
}

function CheckInsideBoxA2(tx, ty, bx, by, w, h){
	if(tx < bx){return false;}
	if(tx > bx+w){return false;}
	if(ty < by){return false;}
	if(ty > by+h){return false;}
	return true;
}

function CheckForMenuAction(type){
	if(type=="Confirm"){
		return GetVirtualKeyState(VK_OK)==KEY_PUSH; //||GetMouseState(MOUSE_LEFT)==KEY_PUSH;
	}
	else if(type=="Cancel"){
		return GetVirtualKeyState(VK_CANCEL)==KEY_PUSH; //||GetMouseState(MOUSE_RIGHT)==KEY_PUSH;
	}
}

function CheckForMenuActionB1(type, state){
	if(type=="Confirm"){
		if(!IsMouseActive){
			return GetVirtualKeyState(VK_OK)==state
		}else{
			return GetMouseState(MOUSE_LEFT)==state;
		}
	}
	else if(type=="Cancel"){
		if(!IsMouseActive){
			return GetVirtualKeyState(VK_CANCEL)==state
		}else{
			return GetMouseState(MOUSE_RIGHT)==state;
		}
	}
}




function LoadAvailablePlayers(forcereset){
	if(IsPlayersLoaded){return;}
	//PlayLoadingAnimationB1("Available Players");
	GetLoadFreePlayerScriptList;
	IsPlayersLoaded=true;
}

function PlayLoadingAnimationB1(type){
	let LoadText = DrawSubMenuText("Now Loading... "~type);
	Obj_SetRenderPriority(LoadText, 1);
	ObjRender_SetPosition(LoadText, 48, 424, 0);
	ObjText_SetFontSize(LoadText,20*Font_Sub_Modifier);
	yield;
	waitforunload;
	
	task waitforunload{
		yield;
		ReturnToTitleB1(LoadText, 25);
	}
	

}

function SaveOptionsAreaData{
	if(SAVEPACKAGEDATA){
		SetAreaCommonData("OptionConfig", "Options", [options, Global_LastSelection]);
		SaveCommonDataAreaA1("OptionConfig");
	}else{WriteLog("Saving to area data \"OptionConfig\" failed, as SAVEPACKAGEDATA is set to false.");}
}

function SaveSpellBuilderAreaData{
	if(SAVEBUILDERDATA){
		SaveCommonDataAreaA1("ScriptBuilderData");
	}else{WriteLog("Saving to area data \"ScriptBuilderData\" failed, as SAVEBUILDERDATA is set to false.");}
}


function DrawSubMenuText(txtStr){
	let objTxt = ObjText_Create;
	ObjText_SetText(objTxt,txtStr);
	ObjText_SetFontSize(objTxt,12*Font_Sub_Modifier);
	ObjText_SetFontType(objTxt,Font_Sub_Name);
	let col = [rand(64,255), rand(64,255), rand(64,255)];
	ObjText_SetFontBorderType(objTxt,BORDER_FULL);
	ObjText_SetFontBorderColor(objTxt,48,48,48);
	ObjText_SetFontBorderWidth(objTxt,1);
	ObjText_SetHorizontalAlignment(objTxt, ALIGNMENT_LEFT);
	ObjText_SetMaxWidth(objTxt, 900);
	Obj_SetRenderPriority(objTxt, 0.75);
	return objTxt;
}

function DrawSubMenuTextB1(txtStr){
	let objTxt = ObjText_Create;
	ObjText_SetText(objTxt,txtStr);
	ObjText_SetFontSize(objTxt,12);
	let col = [rand(64,255), rand(64,255), rand(64,255)];
	ObjText_SetFontBorderType(objTxt,BORDER_FULL);
	ObjText_SetFontBorderColor(objTxt,48,48,48);
	ObjText_SetFontBorderWidth(objTxt,1);
	ObjText_SetHorizontalAlignment(objTxt, ALIGNMENT_LEFT);
	ObjText_SetMaxWidth(objTxt, 900);
	Obj_SetRenderPriority(objTxt, 0.75);
	return objTxt;
}

function DrawText(txtStr, txtX, txtY, txtSize, txtWidth, presetTxtColor, txtPriority){
	let SnowDrawText = ObjText_Create;
	ObjText_SetText(SnowDrawText,txtStr);
	SetTextColor;
	ObjText_SetFontSize(SnowDrawText,txtSize);
	ObjText_SetHorizontalAlignment(SnowDrawText, ALIGNMENT_LEFT);
	ObjText_SetFontBorderWidth(SnowDrawText,1);
	ObjText_SetFontBorderType(SnowDrawText,BORDER_FULL);
	ObjText_SetMaxWidth(SnowDrawText, txtWidth);
	Obj_SetRenderPriority(SnowDrawText, txtPriority);
	ObjRender_SetPosition(SnowDrawText, txtX, txtY, 0);
	
	SetTextColor;
	
	task SetTextColor{
		if(presetTxtColor=="black"){
			ObjText_SetFontColorTop(SnowDrawText,42,42,42);
			ObjText_SetFontColorBottom(SnowDrawText,42,42,42);
			ObjText_SetFontBorderColor(SnowDrawText,142,142,142);
		}
		if(presetTxtColor=="red"){
			ObjText_SetFontColorTop(SnowDrawText,175,20,111);
			ObjText_SetFontColorBottom(SnowDrawText,190,10,123);
			ObjText_SetFontBorderColor(SnowDrawText,142,142,142);
		}
		if(presetTxtColor=="blue"){
			ObjText_SetFontColorTop(SnowDrawText,20,80,175);
			ObjText_SetFontColorBottom(SnowDrawText,80,50,175);
			ObjText_SetFontBorderColor(SnowDrawText,142,142,142);
		}
		if(presetTxtColor=="white"){
			ObjText_SetFontColorTop(SnowDrawText,255,255,255);
			ObjText_SetFontColorBottom(SnowDrawText,185,185,185);
			ObjText_SetFontBorderColor(SnowDrawText,32,32,32);
		}
	}
	
	return SnowDrawText;
}


function CreateSelectMarker{
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.74);
	ObjPrim_SetTexture(obj, img_frame);
	ObjSprite2D_SetSourceRect(obj, 48, 416, 176, 464);
	ObjSprite2D_SetDestRect(obj, -128, -64, 128, 64);
	ObjRender_SetAlpha(obj, 204);
	return obj;
}

function CreateSpriteObject(path){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.74);
	ObjPrim_SetTexture(obj, path);
	return obj;
}

function CreateMenuImage(image){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.6);
	ObjPrim_SetTexture(obj, image);
	ObjSprite2D_SetSourceRect(obj, 0, 0, 640, 480);
	ObjSprite2D_SetDestRect(obj, 0, 0, 640, 480);
	ObjRender_SetPosition(obj, 0, 0, 0);
	return obj;
}

function ObjRender_SetColorRGBCycle(objid, cycle, satmod){
	ObjRender_SetColor(objid, sin(cycle)*255*satmod, sin(cycle+120)*255*satmod, sin(cycle+240)*255*satmod);
}

task ReturnToTitle(fadeid){
	descent(x in 0..14){
		ObjRender_SetAlpha(fadeid, 255*(x/14));
		yield;
	}
	Obj_Delete(fadeid);
}

task ReturnToTitleB1(fadeid, l){
	descent(x in 0..l){
		ObjRender_SetAlpha(fadeid, 255*(x/l));
		yield;
	}
	Obj_Delete(fadeid);
}

task EnterFromTitle(fadeid){
	ascent(x in 0..14){
		ObjRender_SetAlpha(fadeid, 255*(x/14));
		yield;
	}
}

task ReturnToTitleC1(fadeid, l, max){
	descent(x in 0..l){
		ObjRender_SetAlpha(fadeid, max*(x/l));
		yield;
	}
	Obj_Delete(fadeid);
}

task EnterFromTitleC1(fadeid, l, max){
	ascent(x in 0..l){
		ObjRender_SetAlpha(fadeid, max*(x/l));
		yield;
	}
}


task EnterFromTitleD1(fadeid, time, spd){
	ascent(i in 0..time){
		let mod = sin(90/(time-1)*i);
		ObjRender_SetX(fadeid, ObjRender_GetX(fadeid)+spd*(1-mod));
		ObjRender_SetAlpha(fadeid, 255*mod);
		yield;
	}
}

task ReturnToTitleD1(fadeid, time, spd){
	ascent(i in 0..time){
		let mod = sin(90/(time-1)*i);
		ObjRender_SetX(fadeid, ObjRender_GetX(fadeid)+spd*(1-mod));
		ObjRender_SetAlpha(fadeid, 255-255*mod);
		yield;
	}
	Obj_Delete(fadeid);
}

task FadeObjectA1(objid, init, val){
	init = max(min(init+val, 255), 0);
	while(val > 0 && val < 255){
		ObjRender_SetAlpha(objid, init);
		yield;
		init = max(min(init+val, 255), 0);
	}
}

function MenuMove(inc){
	selecthold+=4;
	lastselection = selection;
	selection+=inc;
}

function SafeAssignA1(value, maxvalue){
	//Meant for array assigning from common data
	return min(value, maxvalue);
}

function SafeAssignB1(arrayv, intended){
	//Meant for array assigning from common data
	if(intended > length(arrayv)-1){
		WriteLog("Warning! The following array is shorter than the expected value of \"" ~ IntToString(intended) ~ "\": ");
		WriteLog(arrayv);
		WriteLog(IntToString(length(arrayv)-1) ~ " was returned instead.");
		return length(arrayv)-1;
	}
	return intended;
}




task CreateObjectSound(path, name){
	let objSound = ObjSound_Create;
	ObjSound_Load(objSound, path);
	ObjSound_SetSoundDivision(objSound, SOUND_SE);
	ObjSound_SetRestartEnable(objSound, true);
	GlobalSounds = GlobalSounds~[objSound];
	GlobalSndStr = GlobalSndStr~[name];
	SetCommonData("GlobalSoundData", GlobalSounds);
	SetCommonData("GlobalSndStrData", GlobalSndStr);
	if(name == "se_pause" || name == "se_cancel00" || name == "se_ok00" || name == "se_invalid"){
		Obj_SetValue(objSound, "NoPause", true);
		ObjSound_SetRestartEnable(objSound, false);
	}
}

task PlayMusic(name, force){
	PlayMusicB1(name, force, 0, 0);
}

task PlayMusicB1(name, force, start, end){
	loop(2){WriteLog("Attempting to Run " ~ name);}
	if(name == CurrentBGMID&&!force){return;}
	
	ObjSound_Stop(CurrentBGM);
	Obj_Delete(CurrentBGM);
	loop(2){WriteLog("Music Change Enlabled");yield;}
	CurrentBGM = ObjSound_Create;
	CurrentBGMID = name;
	ObjSound_Load(CurrentBGM, current~"source/Music/"~name~".ogg");
	ObjSound_SetSoundDivision(CurrentBGM, SOUND_BGM);
	ObjSound_SetRestartEnable(CurrentBGM, true);
	ObjSound_SetVolumeRate(CurrentBGM, options[0]);
	ObjSound_SetLoopEnable(CurrentBGM, true);
	if(end > 1){
		if(end > 3000){
			ObjSound_SetLoopSampleCount(CurrentBGM, start, end);
		}else{
			ObjSound_SetLoopTime(CurrentBGM, start, end);
		}
	}
	ObjSound_Play(CurrentBGM);
}

task DisplayFPS{
	//return;
	let objText = ObjText_Create;
	ObjText_SetFontSize(objText, 11);
	ObjText_SetFontBold(objText, true);
	ObjText_SetFontColorTop(objText, 255, 255, 255);
	ObjText_SetFontColorBottom(objText, 160, 160, 255);
	ObjText_SetFontBorderType(objText, BORDER_FULL);
	ObjText_SetFontBorderColor(objText, 32, 32, 32);
	ObjText_SetFontBorderWidth(objText, 1);
	ObjText_SetHorizontalAlignment(objText, ALIGNMENT_RIGHT);
	ObjText_SetMaxWidth(objText, GetScreenWidth - 4);
	Obj_SetRenderPriority(objText, 1);
	ObjRender_SetX(objText, 0);
	ObjRender_SetY(objText, GetScreenHeight - 12);
	
	EnterFromTitle(objText);

	loop{
		ObjText_SetText(objText, vtos("1.2f", GetCurrentFps) ~ "fps");
		if(IsStgFieldActive){
			ObjRender_SetAlpha(objText, 0);
		}else{
			ObjRender_SetAlpha(objText, 255);
		}
		yield;
	}
}


function IsAllKeysFree{
	return GetVirtualKeyState(VK_LEFT) == KEY_FREE &&
	GetVirtualKeyState(VK_RIGHT) == KEY_FREE &&
	GetVirtualKeyState(VK_UP) == KEY_FREE &&
	GetVirtualKeyState(VK_DOWN) == KEY_FREE;
}


function GetDistance(x1,y1,x2,y2){
	return(((x2-x1)^2+(y2-y1)^2)^(1/2))
}

function GetDistanceB1(x1, x2){
	return absolute(x1-x2);
}

function AngleToLocation(x1, y1, x2, y2){
	return atan2(y2 - y1, x2 - x1);
}

function GetFinalDirectoriesInPathA1(str, depth){
	depth = max(0, depth-1);
	let point = length(str);
	descent(i in 0..length(str)){
		if(str[i-1..i] == "/"){
			if(depth == 0){
				return str[i..point];
			}else{
				depth--;
			}
		}
	}
	RaiseError("GetFinalDirectoriesInPathA1 received an invalid path for the string.");
}

function GetIntegerSign(num){
	if(num > 0){return 1;}
	return -1;
}


/*
Reading ALL singles 1 folder deep from the specified folder

	let CharNames = GetDirectoryList(current~"boss/");
	let CacheNames = [];
	ascent(i in 0..length(CharNames)){
		let StrPath = CharNames[i];
		let Path = StrPath[0..length(StrPath)-1][0..length(StrPath)-1];
		let Name = GetFinalDirectoriesInPathA1(Path, 1);
		ObjText_SetText(LoadText, "Now Loading: Boss Data - "~Name);
		
		CacheNames = CacheNames ~ [Name];
		
		if(length(CacheNames) > 8){
			DayNames = DayNames~[CacheNames];
			CacheNames = [];
		}
		
		//CreateSpellChoice("Testing", "", [""], [""]);
		
		//["{Test Comment)[r]"~Name~"'s Nonspell"]
		
		
		let Scripts = GetScriptPathList(Path~"/", TYPE_SCRIPT_SINGLE);
		let numScripts = length(Scripts);
		let numComments = 0;
		
		
		let InfoFile = ObjFile_Create(OBJ_FILE_TEXT);
		ObjFile_Open(InfoFile, Path~"/Information.txt");
		
		let FileYSize = ObjFileT_GetLineCount(InfoFile);
		let tx = 0;
		let ty = 0;
		let SetStep = 0;
		
		let ScripterNames = [];
		let ImagePaths = [];
		let AttackComments = [];
		let SpellNames = [];
		
		let SpellBuilder = "";
		let HasCommentBegan = false;
		
		while(ty < FileYSize){
			let line = ObjFileT_GetLineText(InfoFile, ty)~"()";
			
			let linelen = length(line)-2;
			
			let FirstChar = line[0..1];
			if(linelen > 0){
				if(FirstChar == "@" || FirstChar == "+"){
					if(length(SpellBuilder)>0){
						AttackComments = AttackComments~[SpellBuilder];
					}
					if(FirstChar == "+"){ty = FileYSize; break;}
				}
				if(FirstChar == "@"){
					numComments++;
					SpellBuilder = "";
					SpellNames = SpellNames~[line[1..linelen]];
					ty++;
					let sNames = ObjFileT_GetLineText(InfoFile, ty);
					let rNames = SplitString(sNames[0..length(sNames)], ",");
					ScripterNames = ScripterNames~[rNames];
					ty++;
					
					let sImage = ObjFileT_GetLineText(InfoFile, ty);
					let rImage = SplitString(sImage[0..length(sImage)], ",");
					
					ImagePaths = ImagePaths~[rImage];
				}else{
					SpellBuilder = SpellBuilder~line[0..linelen]~"[r]";
				}
			}
			ty++;
		}
		Obj_Delete(InfoFile);
		
		
		
		if(length(SpellNames) <= 0){
			ascent(i in 0..numScripts){
				let Script = Scripts[i];
				let FileName = GetFinalDirectoriesInPathA1(Script, 1);
				SpellNames = SpellNames~[Name~"'s "~FileName];
			}
		}
		if(length(AttackComments) <= 0){
			ascent(i in 0..numScripts){
				let Script = Scripts[i];
				let FileName = GetFinalDirectoriesInPathA1(Script, 1);
				AttackComments = AttackComments~[Name~"'s undefined spell comment for "~FileName
				~"[r][r]Comments, names, cutins, are temporarily disabled until the menu remake."];
			}
		}
		if(length(ScripterNames) <= 0){
			ascent(i in 0..numScripts){
				let Script = Scripts[i];
				let FileName = GetFinalDirectoriesInPathA1(Script, 1);
				ScripterNames = ScripterNames~[["Undefined Scripter(s)"]];
			}
		}
		let FinalImagePaths = [];
		if(length(ImagePaths) <= 1){
			ascent(i in 0..numScripts){
				FinalImagePaths = FinalImagePaths~[[current~"img/boss/System Template/Undefined.png"]];
			}
		}else{
			ascent(x in 0..numScripts){
				let localArray = [];
				ascent(i in 0..length(ImagePaths[x])){
					localArray = localArray ~ [current~"img/boss/"~Name~"/"~ImagePaths[x][i]];
					LImageB(localArray[i]);
				}
				FinalImagePaths = FinalImagePaths ~ [localArray];
			}
		}
		
		
		let RName = [];
		ascent(i in 0..length(ScripterNames)){
			let LocalScripters = ScripterNames[i];
			let lstr = "";
			
			ascent(x in 0..length(LocalScripters)){
				if(x != 0){lstr = lstr~", ";}
				
				lstr = lstr~LocalScripters[x];
			}
			RName = RName ~ [lstr]
		}
		
		ascent(i in 0..numScripts){
			let Script = Scripts[i];
			let FileName = GetFinalDirectoriesInPathA1(Script, 1);
			
			let MainAttack = SpellNames[i];
			let ScriptAttackName = MainAttack[0..length(MainAttack)];
			
			let CommentAttack = AttackComments[i];
			let ScriptAtkComments = CommentAttack[0..length(CommentAttack)];
			
			CreateSpellChoice(Name, Script, [ScriptAttackName], [RName[i]~"[r]"~ScriptAtkComments], [FinalImagePaths[i]]);
		}
*/



//dumb local{} not working at the top
