#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/Function_Effect.dnh"
#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";
//let imgYinYangs = current~"Yin-Yangs.png";
//let imgGiant = current~"GiantYin-Yang.png";

let objPlayer = GetPlayerObjectID;


@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(48-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	
	SetEnemyAnimationA1(Enemy);
	// ObjRender_SetPosition(Enemy, GetStgFrameWidth/2+42, -64, 0);
	ObjMove_SetDestAtWeight(Enemy,(GetStgFrameWidth/2-1)-rand(0,90),rand(70,120),13,5);
			
	SetInvincibility(Enemy, 160, 84, 80);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	yield;
	loop(60){yield;}
	ConcentrationA1(Enemy,"CHERRY",60,4,150,[255,192,56]);
	PlaySoundB1("se_ch02",60);
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_Delete(Enemy);
	EnemyDead = true;
	PlaySound("se_tan00");
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		InitEnemy(0.3, current~"GiantYin-Yang.png");
		if(!Hold(70)){break;}
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			
			ObjAnim_SetAttackA2(Enemy, 70);
			EnemySweepRight;
			if(!Hold(180)){break;}
			ObjMove_SetDestAtWeight(Enemy,(GetStgFrameWidth/2+1)+rand(0,90),rand(70,120),13,5);
			if(!Hold(100)){break;}
		
			ObjAnim_SetAttackA2(Enemy, 70);
			EnemySweepLeft;
			if(!Hold(180)){break;}
			ObjMove_SetDestAtWeight(Enemy,(GetStgFrameWidth/2-1)-rand(0,90),rand(70,120),13,5);
			if(!Hold(100)){break;}
		}
		return;
		
	}
}

task EnemySweepRight{
	let YYs = [];
	let start = 75;
	let dir = rand(0,360);
	ascent(i in 0..9){
		YYs = append(YYs,CreateYinYangY2(EnemyX+20*cos(start),EnemyY+20*sin(start), 0, 0));
		ObjMove_SetAngle(YYs[i],start);
		ObjMove_SetSpeed(YYs[i],4);
		ObjMove_SetAcceleration(YYs[i],-0.1);
		ObjMove_SetMaxSpeed(YYs[i],0);
		
		start-=18;
		if(!Hold(3)){break;}
	}
	start = 75;
	wait(40);
	ascent(i in 0..9){
		YYLaserR(YYs[i],dir,start,52,1052);
		start-=18;
		dir+=22.5;
	}
	wait(120); 
	ascent(i in 0..9){
		ObjEnemy_SetLife(YYs[i],0);
		wait(3);
	}
}

task YYLaserR(obj,direct,direct2,c,c2){
	if (Obj_IsDeleted(obj)) {return;}
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	let dir = direct;
	PlaySoundB1("se_laser01",60);
	ascent(i in 0..3){
		let las = CreateLooseLaserA1(x,y,4,dir+i*360/3,150,10,c2,10);
		waitchange(las,-0.1,0,40);
		Lasersplode(las,25,dir+i*360/3,c,20);
	}
}

task Lasersplode(las,division,aim,graphic,delay){ 
	let DelX = [];
	let DelY = [];
	let DelDir = [];
	let spread = aim;
	//wait(delay);
	ascent(i in 0..ObjLaser_GetLength(las)/division) {
		DelX = append(DelX,ObjMove_GetX(las));
		DelY = append(DelY,ObjMove_GetY(las));
		DelDir = append(DelDir,ObjMove_GetAngle(las));
		wait(division/3);
	}
	wait(20);
		PlaySoundB1("se_kira01",60);
		ascent(i in 0..ObjLaser_GetLength(las)/division) {
			loop(3){
				let shot = CreateObjShotA2(DelX[i],DelY[i],5-(i*0.4),spread+i*16,-0.1-(i*0.005),2-(i*0.15),graphic,10);	
				ObjRender_SetBlendType(shot,BLEND_ADD_ARGB);
				spread+=360/3;
				//ObjMove_AddPatternA1(shot,50,2-(i*0.15),-spread+i*16);
			}
		//spread+=360/(ObjLaser_GetLength(las)/division);
		//spread+=360/3/2;
	}
	Obj_Delete(las);
}

task EnemySweepLeft{
	let YYs = [];
	let start = 115;
	let dir = rand(0,360);
	ascent(i in 0..9){
		YYs = append(YYs,CreateYinYangY2(EnemyX+20*cos(start),EnemyY+20*sin(start), 0, 0));
		ObjMove_SetAngle(YYs[i],start);
		ObjMove_SetSpeed(YYs[i],4);
		ObjMove_SetAcceleration(YYs[i],-0.1);
		ObjMove_SetMaxSpeed(YYs[i],0);
		
		start+=18;
		if(!Hold(3)){break;}
	}
	start = 75;
	wait(40); //Replace with hold
	ascent(i in 0..9){
		YYLaserR(YYs[i],dir,start,40,1057);
		start+=18;
		dir-=22.5;
	}
	wait(120); 
	ascent(i in 0..9){
		ObjEnemy_SetLife(YYs[i],0);
		wait(3);
	}
}


task waitchange(obj,acc,speed,t){
		wait(t);
		ObjMove_SetAcceleration(obj,acc);
		ObjMove_SetMaxSpeed(obj,speed);
	}

/*task MakeYinYangs(num,start,dist,way){
	ascent(m in 0..num) { 
		YYs = append(YYs,ObjEnemy_Create(OBJ_ENEMY)); 
        ObjMove_SetPosition(YYs[m],EnemyX+100*cos(start),EnemyY+100*sin(start)); 
        ObjPrim_SetTexture(YYs[m],imgYinYangs);
        ObjSprite2D_SetSourceRect(YYs[m],65,1,94,30); 
        ObjSprite2D_SetDestCenter(YYs[m]); 
        ObjEnemy_Regist(YYs[m]);
		ObjMove_SetAngle(YYs[m],start);
		ObjEnemy_SetLife(YYs[m],150);
		ObjEnemy_SetDamageRate(YYs[m],50,50);
		RotateImg(YYs[m],-8);
		SetHitboxAndOrbiter(YYs[m]);
		start+=dist*way;
		wait(2);
	}
	wait(40);
	ascent(m in 0..num) { 
	YYLaser(YYs[m],ObjMove_GetAngle(YYs[m])*GetAngleToPlayer(YYs[m]));
	}
	
	task SetHitboxAndOrbiter(obj){
		let x = ObjMove_GetX(obj);
		let y = ObjMove_GetY(obj);
		let obj2 = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjPrim_SetTexture(obj2,imgYinYangs);
        ObjSprite2D_SetSourceRect(obj2,64,32,96,64); 
        ObjSprite2D_SetDestCenter(obj2); 
		RotateImg(obj2,6);
		while(ObjEnemy_GetInfo(obj, INFO_LIFE) > 0) {
			x = ObjMove_GetX(obj);
			y = ObjMove_GetY(obj);
			ObjEnemy_SetIntersectionCircleToShot(obj, x, y, 14);
			ObjEnemy_SetIntersectionCircleToPlayer(obj, x, y, 14);
			ObjRender_SetPosition(obj2,x,y,0);
			yield;
		}
		ExplosionA1(obj,"CHERRY",[0,0,128],[0,0,128]);
		Obj_Delete(obj);
		Obj_Delete(obj2);
	}
}*/