#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/Function_Effect.dnh"
#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";
//let imgYinYangs = current~"Yin-Yangs.png";
//let imgGiant = current~"GiantYin-Yang.png";

let objPlayer = GetPlayerObjectID;


@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(48-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	
	SetEnemyAnimationA1(Enemy);
	// ObjRender_SetPosition(Enemy, GetStgFrameWidth/2+42, -64, 0);
	ObjMove_SetDestAtWeight(Enemy,(GetStgFrameWidth/2-1)-rand(35,45),rand(80,140),13,5);
			
	SetInvincibility(Enemy, 170, 120, 95);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	yield;
	loop(45){yield;}
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_Delete(Enemy);
	EnemyDead = true;
	PlaySound("se_tan00");
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		InitEnemy(0.3, current~"GiantYin-Yang.png");
		wait(60);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			ObjAnim_SetAttackA2(Enemy, 140);
			GiantSweep(130+rand(-10,10),-1,0);
			if(!Hold(70)){break;}
			Echo(rand(-40,40),rand(-40,40));
			if(!Hold(30)){break;}
			Echo(rand(-40,40),rand(-40,40));
			if(!Hold(60)){break;}
			ObjMove_SetDestAtWeight(Enemy,(GetStgFrameWidth/2+1)+rand(35,45),rand(80,140),13,5);
			if(!Hold(140)){break;}
			ObjAnim_SetAttackA2(Enemy, 140);
			GiantSweep(50+rand(-10,10),1,256);
			if(!Hold(70)){break;}
			Echo(rand(-40,40),rand(-40,40));
			if(!Hold(30)){break;}
			Echo(rand(-40,40),rand(-40,40));
			if(!Hold(60)){break;}
			ObjMove_SetDestAtWeight(Enemy,(GetStgFrameWidth/2-1)-rand(35,45),rand(80,140),13,5);
			if(!Hold(140)){break;}
		}
		
		return;
		
	}
}

task GiantSweep(start,way,col){
	let YYs = [];
	let dir = start;
	ConcentrationA1(Enemy,"CHERRY",60,4,150,[255,192,56]);
	PlaySoundB1("se_ch02",60);
	ascent(i in 0..7){
		YYs = append(YYs,CreateYinYangY2(EnemyX+20*cos(dir),EnemyY+20*sin(dir), 0, col));
		if (col == 256) {SetYinExplosionColor(YYs[i], "CHERRY", 255, 0, 0, 128, 128, 128);}
		ObjMove_SetAngle(YYs[i],dir);
		ObjMove_SetSpeed(YYs[i],4);
		ObjMove_SetAcceleration(YYs[i],-0.1);
		ObjMove_SetMaxSpeed(YYs[i],1);
		ObjEnemy_SetLife(YYs[i], 1500);
		Resize(YYs[i],45);
		wait(3);
		dir+=37*way;
	}
}

task Echo(xr,yr){
	let dir = rand(0,360);
	PlaySoundB1("c_shot3",60);
	ascent(i in 0..4){
		loop(14){
		let shot = CreateObjShotA1(EnemyX+xr,EnemyY+yr,1+(i*0.5),dir,52,15);
		dir+=360/14;
		//ObjRender_SetBlendType(shot,BLEND_ADD_ARGB);
		ReflectWallsC(shot,47);
		}
		dir+=360/14/2;
	}
	
	task ReflectWallsC(obj,c) {
		
		while (ObjMove_GetX(obj)>0&&ObjMove_GetX(obj)<GetStgFrameWidth) {yield;}
		if(Obj_IsDeleted(obj)){return;}
		PlaySoundB1("se_kira00",40);
		let nshot = CreateObjShotA1(ObjMove_GetX(obj), ObjMove_GetY(obj), ObjMove_GetSpeed(obj), 180-ObjMove_GetAngle(obj), c, 6);
		Obj_Delete(obj);
	}
}

task waitchange(obj,acc,speed,t){
		wait(t);
		ObjMove_SetAcceleration(obj,acc);
		ObjMove_SetMaxSpeed(obj,speed);
	}
	
task Resize(obj,t){
	wait(t);
	PlaySoundB1("se_big",60);
	let count = 1/8;
	loop(150){
	Obj_SetValue(obj, "YinScale", count);
	count+=(0.875)/150;
	yield;
	}
}

/*task MakeYinYangs(num,start,dist,way){
	ascent(m in 0..num) { 
		YYs = append(YYs,ObjEnemy_Create(OBJ_ENEMY)); 
        ObjMove_SetPosition(YYs[m],EnemyX+100*cos(start),EnemyY+100*sin(start)); 
        ObjPrim_SetTexture(YYs[m],imgYinYangs);
        ObjSprite2D_SetSourceRect(YYs[m],65,1,94,30); 
        ObjSprite2D_SetDestCenter(YYs[m]); 
        ObjEnemy_Regist(YYs[m]);
		ObjMove_SetAngle(YYs[m],start);
		ObjEnemy_SetLife(YYs[m],150);
		ObjEnemy_SetDamageRate(YYs[m],50,50);
		RotateImg(YYs[m],-8);
		SetHitboxAndOrbiter(YYs[m]);
		start+=dist*way;
		wait(2);
	}
	wait(40);
	ascent(m in 0..num) { 
	YYLaser(YYs[m],ObjMove_GetAngle(YYs[m])*GetAngleToPlayer(YYs[m]));
	}
	
	task SetHitboxAndOrbiter(obj){
		let x = ObjMove_GetX(obj);
		let y = ObjMove_GetY(obj);
		let obj2 = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjPrim_SetTexture(obj2,imgYinYangs);
        ObjSprite2D_SetSourceRect(obj2,64,32,96,64); 
        ObjSprite2D_SetDestCenter(obj2); 
		RotateImg(obj2,6);
		while(ObjEnemy_GetInfo(obj, INFO_LIFE) > 0) {
			x = ObjMove_GetX(obj);
			y = ObjMove_GetY(obj);
			ObjEnemy_SetIntersectionCircleToShot(obj, x, y, 14);
			ObjEnemy_SetIntersectionCircleToPlayer(obj, x, y, 14);
			ObjRender_SetPosition(obj2,x,y,0);
			yield;
		}
		ExplosionA1(obj,"CHERRY",[0,0,128],[0,0,128]);
		Obj_Delete(obj);
		Obj_Delete(obj2);
	}
}*/