#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/Function_Effect.dnh"
#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let imgEnemycutin = current~"YuugiCutinDairi.png"; 

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(80);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	// ObjRender_SetPosition(Enemy, GetStgFrameWidth/2+42, -64, 0);
	ObjMove_SetDestAtWeight(Enemy, GetCommonData("StarX1", GetStgFrameWidth/2),
		GetCommonData("StarY1", GetStgFrameHeight/3), 13, 5);
			
	SetInvincibility(Enemy, 220, 27, 20);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	yield;
	// loop(65){yield;}
	PlaySoundB1("se_cat00",60);
	ObjCutin_SetSpellcardM4("Balance Sign \"Supernatural Split\"", 3500000, "YABUSAME", imgEnemycutin, 255, 192, 56);
	ObjEnemyBossScene_StartSpell(objScene);
	if(!Hold(20)) {break;}
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_Delete(Enemy);
	EnemyDead = true;
	PlaySound("se_tan00");
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		InitEnemy(0.3, current~"GiantYin-Yang.png");
		if(!Hold(40)) {break;}
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			ObjAnim_SetAttackA2(Enemy, 200);
			MultiSweep(1);
			if (!Hold(700)) {break;}
			ObjAnim_SetAttackA2(Enemy, 200);
			MultiSweep(-1);
			if (!Hold(700)) {break;}
			}
			yield;
	}
}

task MultiSweep(way){
	let dir = 50;
	let r = rand(65,115);
	loop(8){
		YYLead(dir+r,90);
		dir += 360/8*way;
		wait(2);
	}
	wait(500);
	ConcentrationA1(Enemy,"CHERRY",60,4,150,[255,192,56]);
	PlaySoundB1("se_ch02",60);
}

task YYLead(dir,firedir){
	let lead = CreateYinYangY2(EnemyX+20*cos(dir),EnemyY+20*sin(dir), 0, 512);
	let set = 1;
	SetYinExplosionColor(lead, "CHERRY", 255, 0, 255, 128, 128, 128);
	let r = rand(0,360);
	ObjMove_SetAngle(lead,dir);
	ObjMove_SetSpeed(lead,4);
	ObjMove_SetAcceleration(lead,-0.1);
	ObjMove_SetMaxSpeed(lead,0);
	ObjEnemy_SetLife(lead, 100);
	Resize(lead,0.2,20);
	ascent(i in 0..10){
		YYorbiter(lead,i*360/10+r,set);
		set*=-1;
	}
	let count = 10;
	wait(50);
	loop(9){
		BigLaser(lead,dir,count);
		count+=20;
		wait(50);
	}
	wait(100);
	ObjEnemy_SetLife(lead, 0);
	
	
	task BigLaser(obj,firedir,sp){
		let spread = -sp;
		PlaySoundB1("se_gun00",50);
		loop(2){
			if (Obj_IsDeleted(obj)) {break;}
			let las = CreateStraightLaserA1(ObjMove_GetX(obj),ObjMove_GetY(obj),firedir+spread,500,15,30,113,50);
			ObjRender_SetColor(las,256,128,188);
			spread+=sp*2;
		}
	}
}

task waitchange(obj,acc,speed,AV,t){
		wait(t);
		ObjMove_SetAcceleration(obj,acc);
		ObjMove_SetMaxSpeed(obj,speed);
		ObjMove_SetAngularVelocity(obj,AV);
	}
	
task Resize(obj,size,t){
	wait(t);
	let count = 1/8;
	loop(50){
	Obj_SetValue(obj, "YinScale", count);
	count+=(size)/50;
	yield;
	}
}

task YYorbiter(obj,sinestart,fire){

	let count = sinestart;
	let rad = 0;
	let timer = 0;

	let lx = ObjMove_GetX(obj);
	let ly = ObjMove_GetY(obj);
	let x = EnemyX;
	let y = EnemyY;
	// let cx = 0;
	// let cy = 0;
	
	let dist = 32;
	let sspd = 1;
	let circum = 2*pi*dist;
	let time = circum/sspd;
	let yy = CreateYinYangY2(lx+(dist)*cos(count),ly+(dist)*sin(count), 0, 512);
	ObjEnemy_SetLife(yy, 60);
	SetYinExplosionColor(yy, "CHERRY", 255, 0, 255, 128, 128, 128);

	
	let av = 360/time;
	ObjMove_SetSpeed(yy, circum/time);
	ObjMove_SetAngle(yy, sinestart+90);
	ObjMove_SetAngularVelocity(yy, av);
	
	
	ascent(i in 0..50){
		DoActions;
		Obj_SetValue(yy, "YinScale", 1/8/49*i);
		yield;
	}
	
	while(!Obj_IsDeleted(obj)&&!Obj_IsDeleted(yy)){
		DoActions;
		timer++;
		if (timer == 46&&fire == 1) {
			PlaySoundB1("se_tan00",40);
			let shot = CreateObjShotA2(x, y, 4,ObjMove_GetAngle(yy)-90,-0.06,2,53,10); 
			ObjRender_SetBlendType(shot,BLEND_ADD_ARGB); 
			timer = 0;}
		yield;
	}
	ObjMove_SetAcceleration(yy,-0.01);
	ObjMove_SetMaxSpeed(yy,2);
	PlaySoundB1("se_kira00",60);
	//let atp = AngleToPlayer(x, y);
	//Resize(yy,0.1,10);
	let count2 = 0;
	while(!Obj_IsDeleted(yy)){
		av = max(0, av-0.025);
		ObjMove_SetAngularVelocity(yy, 0);
		x = ObjMove_GetX(yy);
		y = ObjMove_GetY(yy);
		if (count2%10==0){CreateObjShotA2(x,y,4-(count2*0.025),ObjMove_GetAngle(yy)-180,-0.2,2-(count2*0.025),139,20);}
		if (count2 < 32) {count2+=2;}
		yield;
	}
	if(CheckOutsideScreenA2(x, y, 8)){return;}
	
	

	//ObjRender_SetBlendType(shot,BLEND_ADD_ARGB);
	wait(4);
	
	
	sub DoActions{
		if(!Obj_IsDeleted(yy)){
			x = ObjMove_GetX(yy);
			y = ObjMove_GetY(yy);
		}
		if(lx != ObjMove_GetX(obj) && !Obj_IsDeleted(obj)){
			// cx = ObjMove_GetX(obj)-lx;
			// cy = ObjMove_GetY(obj)-ly;
			ObjMove_SetPosition(yy, x+ObjMove_GetX(obj)-lx, y+ObjMove_GetY(obj)-ly);
			lx = ObjMove_GetX(obj);
			ly = ObjMove_GetY(obj);
		}
	}
}


