#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let imgEnemycutin = current~"YuugiCutinDairi.png"; 

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(70);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	ObjMove_SetDestAtWeight(Enemy, GetCommonData("StarX1", GetStgFrameWidth/2),
		GetCommonData("StarY1", GetStgFrameHeight/3), 13, 5);
			
	SetInvincibility(Enemy, 140, 10, 11);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	yield;
	// loop(65){yield;}
	PlaySoundB1("se_cat00",60);
	ObjCutin_SetSpellcardM4("Thorned Helix \"Oni's Right of Passage\"", 3500000, "YABUSAME", imgEnemycutin, 255, 192, 56);
	ObjEnemyBossScene_StartSpell(objScene);
	if(!Hold(60)) {break;}
	ConcentrationA1(Enemy,"CHERRY",60,4,150,[255,192,56]);
	PlaySoundB1("se_ch02",60);
	if(!Hold(60)) {break;}
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_Delete(Enemy);
	EnemyDead = true;
	PlaySound("se_tan00");
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
	
		ObjAnim_SetAttackA2(Enemy, 100000);
		if(!Hold(30)) {break;}
		YuuTwirl1;
		if(!Hold(400)){break;}
		YuuTwirl2;
		return;
		
		
	}
}

task YuuTwirl1{
	let dir = 270;
	let way = 1;
	let sp = 3;
	let acc = 0.01;

	loop{
		loop(44){
			loop(4){
				let shot1 = CreateLooseLaserA1(EnemyX+10,EnemyY-40,0.5,dir,60,35,91,10);
				ObjMove_SetAcceleration(shot1, acc);
				ObjMove_SetMaxSpeed(shot1, sp);
				ObjRender_SetBlendType(shot1,BLEND_ADD_ARGB);
				dir+=5.327*way;
				PlaySoundB1("se_laser01",40);
				wait(2);
				if (sp < 3.5) {sp+=0.001;}
				if (acc < 0.03) {acc+=0.0004;}
			}
			CreateObjShotSA2_Y1(EnemyX+10,EnemyY-40,0.5,dir,60,35,acc,sp,60,0.9,25,93,10);
			dir+=5.327*way;
			wait(2);
			if (sp < 3.5) {sp+=0.001;}
			if (acc < 0.03) {acc+=0.0004;}
		}
		way*=-1;
		YuuSplash;
		wait(2);
	}
}

task YuuTwirl2{
	let dir = 270;
	let start = rand(0,360);
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		let flux = 20*sin(start);
		let objShot = CreateObjShotA1(EnemyX+(45+flux)*cos(dir*5.4),EnemyY+(45+flux)*sin(dir*5.4),0.3,-dir,12,10);
		ObjMove_SetAcceleration(objShot, 0.02);
		ObjMove_SetMaxSpeed(objShot, 1.2);
		//ObjRender_SetBlendType(objShot,BLEND_ADD_ARGB);
		Obj_SetRenderPriorityI(objShot,51);
		dir+=5.379;
		start++;
		PlaySoundB1("se_tan02",55);
		wait(2);
	}
}

task YuuSplash{
	wait(50);
	let dir = rand(0,360);
	let sine = rand(0,360);
	let sineinf = 50;
	PlaySoundB1("c_shot",70);
	loop(7){
		sine = 90;
		sineinf = 50;
		ascent(i in 0..26){
			CreateObjShotA1(EnemyX+(10+i*2)*cos(dir),EnemyY+(10+i*2)*sin(dir),1+(i*0.1),dir+sineinf*sin(sine),21,25);
			sine+=30;
			sineinf-=50/26;
		}
		dir+=360/7;
	}	
}

task CreateObjShotSA2_Y1(x, y, spd, ang, lgt, wid, acc, maxspd, rad, slowspd, slowdur, graph, delay){
	//rad = radius to activate
	//slowspd = speed when slowed
	//slowdur = amount of frames before reaches slow spd
	let objShot = ObjShot_Create(OBJ_LOOSE_LASER);
	ObjShot_Regist(objShot);
	ObjMove_SetPosition(objShot, x, y);
	ObjLaser_SetLength(objShot,lgt); //
	ObjLaser_SetRenderWidth(objShot,wid); //
	sethitbox(objShot,wid);
	ObjMove_SetAngle(objShot, ang);
	ObjShot_SetGraphic(objShot, graph);
//	ObjShot_SetIntersectionEnable(objShot, false);
	ObjRender_SetBlendType(objShot,BLEND_ALPHA);
	//Obj_SetValue(objShot, "g_Coll_Ignore_Spawning", true);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	// ObjShot_SetIntersectionEnable(objShot, true);
	//Obj_SetValue(objShot, "g_Coll_Ignore_Spawning", false);
	//GiveCollision(objShot);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	ObjMove_SetSpeed(objShot, spd);
	ObjMove_SetAcceleration(objShot, acc);
	ObjMove_SetMaxSpeed(objShot, maxspd);
	
	while(!Obj_IsDeleted(objShot)){
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		if(GetDistance(x, y, GetPlayerX, GetPlayerY) < rad){
			break;
		}
		yield;
	}
	ObjMove_SetAcceleration(objShot, 0);
	let dist = ObjMove_GetSpeed(objShot) - slowspd;
	let mod = absolute(dist)/dist;
	descent(i in 0..slowdur){
		ObjMove_SetSpeed(objShot, slowspd + dist/(slowdur-1)*i);
		yield;
	}
	
	if(quality<=1){return;}
	while(!Obj_IsDeleted(objShot)){
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		yield;
	}
	ObjShot_BulletBreak(x, y, graph);
	
	task sethitbox(objShot,wid) { //
		while(!Obj_IsDeleted(objShot)){ //
			ObjLaser_SetIntersectionWidth(objShot,wid-20);  //
			yield; //
		} //
	} //
}