#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(5500+50*(argument/12-4));}
	case(EV_REQUEST_TIMER){SetScriptResult(411118-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	ObjRender_SetPosition(Enemy, GetStgFrameWidth/2+42, -64, 0);
	ObjMove_SetDestAtWeight(Enemy, GetCommonData("StarX1", GetStgFrameWidth/2),
		GetCommonData("StarY1", GetStgFrameHeight/3), 13, 5);
			
	SetInvincibility(Enemy, 90, 90, 95);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	// WriteLog(GetScreenOffsetX);
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	yield;
	loop(45){yield;}
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_Delete(Enemy);
	EnemyDead = true;
	PlaySound("se_tan00");
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		InitEnemy(0.3, current~"GiantYin-Yang.png");
	
	
		let argm = round(1.2+argument/18);
		let argi = round(17+argument/2.2/(1+argm*0.14));
		SetShotAutoDeleteClip(460, 128, 228, 460);
		if(!Hold(60)){break;}
		Reflector;
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			
			if(!Hold(50)){break;}
			Intro(1);
			if(!Hold(20)){break;}
			ConcentrationA1(Enemy,"CHERRY",30,4,150,[255,56,56]);
			if(!Hold(70)){break;}
			ObjMove_SetDestAtFrame(Enemy, GetStgFrameWidth, EnemyY, 15);
			while(ObjMove_GetSpeed(Enemy)>1.5){yield}
			ShiftScreenA1(200, 0, 90);
			if(!Hold(130)){break;}
			Intro(-1);
			if(!Hold(20)){break;}
			ConcentrationA1(Enemy,"CHERRY",30,4,150,[255,56,56]);
			if(!Hold(70)){break;}
			ObjMove_SetDestAtFrame(Enemy, 200, EnemyY, 15);
			while(ObjMove_GetSpeed(Enemy)>1.5){yield}
			ShiftScreenA1(-200, 0, 90);
			if(!Hold(130)){break;}
		
		}
	}
}

task Intro(way){
	let dir = 130;
	if (way == -1) {dir = 50;}
	loop(12){
		ascent(i in 0..6){
			 CreateObjShotA1(EnemyX+40*cos(dir+i*7*way),EnemyY+40*sin(dir+i*7*way),0.5+(i*0.18),dir+i*7*way,51,10);
		}
		dir-=175/12*way;
		wait(1);
	}
	wait(5);
	dir = 50;
	if (way == -1) {dir = 130;}
	loop(6){
		ascent(i in 0..6){
			let shot = CreateObjShotA1(EnemyX+40*cos(dir-i*7*way),EnemyY+40*sin(dir-i*7*way),0.5+(i*0.18),dir-i*7*way,214,10);
			GiveBulletScreenDefyA1(shot);
			
			//ReflectBorders(shot);
		}
		dir+=175/6*way;
		wait(2);
	}
	
	
}

task Reflector{
	let dir = 45;
	loop(24){
		//ascent(o in 0..3){
		let shot = CreateObjShotA1(round(EnemyX+40*cos(dir)),round(EnemyY+40*sin(dir)),4,dir,100,10);
		GiveBulletScreenDefyA1(shot);
		ReflectBorders(shot);
		ObjShot_SetSpellResist(shot,true);
		//}
		wait(4);
	}
}

task Lanes{
	let dir = rand(0,360);
	loop(4){
	loop(3){
		loop(10){
			let shot = CreateObjShotA1(EnemyX,EnemyY,1.3,dir,96,10);
			ObjMove_SetAngularVelocity(shot,0.2);
			shot = CreateObjShotA1(EnemyX,EnemyY,1.3,dir,96,10);
			ObjMove_SetAngularVelocity(shot,-0.2);
			dir+=360/10;
		}
		wait(10);
	}
	
	loop(3){
		loop(10){
			let shot = CreateObjShotA1(EnemyX,EnemyY,1.3,dir,89,10);
			ObjMove_SetAngularVelocity(shot,-0.2);
			GiveBulletScreenDefyA1(shot);
			shot = CreateObjShotA1(EnemyX,EnemyY,1.3,dir,89,10);
			ObjMove_SetAngularVelocity(shot,0.2);
			GiveBulletScreenDefyA1(shot);
			dir+=360/10;
		}
		wait(10);
	}
	}
}

task YuuCrash(way){
	let Side;
	loop(40){
		if (way == 1) {Side = GetStgFrameLeft+GetStgFrameWidth-20;}
		if (way == 0) {Side = GetStgFrameLeft-40;}
		ascent(i in 0..2){
			CreateObjShotA1(Side,i*GetStgFrameHeight,2,rand(0,180)+i*180,221,3);
		}
	if(!Hold(2)){break;}
	}
}


task ReflectBordersD(obj) {
		// wait(90);
        while (!Obj_IsDeleted(obj)) {
                if (ObjMove_GetX(obj)<0+GetScreenOffsetX) {
                        ObjMove_SetX(obj, ObjMove_GetX(obj)+ObjMove_GetSpeed(obj));
                        ObjMove_SetAngle(obj,180-ObjMove_GetAngle(obj));
                }
                else if (ObjMove_GetX(obj)>GetStgFrameWidth+GetScreenOffsetX) {
                        ObjMove_SetX(obj,GetStgFrameWidth+GetScreenOffsetX-+ObjMove_GetSpeed(obj));
                        ObjMove_SetAngle(obj,180-ObjMove_GetAngle(obj));
                }
                else if (ObjMove_GetY(obj)<0) {
                        ObjMove_SetY(obj,0-ObjMove_GetY(obj));
                        ObjMove_SetAngle(obj,0-ObjMove_GetAngle(obj));
                }
                else if (ObjMove_GetY(obj)>GetStgFrameHeight) {
                        ObjMove_SetY(obj,GetStgFrameHeight*2-ObjMove_GetY(obj));
                        ObjMove_SetAngle(obj,0-ObjMove_GetAngle(obj));
                }
                yield;
        }
}

task ReflectBorders(obj) {
	// wait(90);
	while (!Obj_IsDeleted(obj)) {
		if (ObjMove_GetX(obj)<0+GetScreenOffsetX) {
			ObjMove_SetX(obj, ObjMove_GetX(obj)+ObjMove_GetSpeed(obj));
			ObjMove_SetAngle(obj,180-ObjMove_GetAngle(obj));
			WriteLog(ObjMove_GetX(obj));
		}
		else if (ObjMove_GetX(obj)>GetStgFrameWidth+GetScreenOffsetX) {
			ObjMove_SetX(obj,ObjMove_GetX(obj)-ObjMove_GetSpeed(obj));
			ObjMove_SetAngle(obj,180-ObjMove_GetAngle(obj));
			// WriteLog(ObjMove_GetX(obj)-GetScreenOffsetX);
		}
		else if (ObjMove_GetY(obj)<0) {
			ObjMove_SetY(obj,0-ObjMove_GetY(obj));
			ObjMove_SetAngle(obj,0-ObjMove_GetAngle(obj));
		}
		else if (ObjMove_GetY(obj)>GetStgFrameHeight) {
			ObjMove_SetY(obj,GetStgFrameHeight*2-ObjMove_GetY(obj));
			ObjMove_SetAngle(obj,0-ObjMove_GetAngle(obj));
		}
		yield;
	}
}


task waitchange(obj,acc,speed,t){
		wait(t);
		ObjMove_SetAcceleration(obj,acc);
		ObjMove_SetMaxSpeed(obj,speed);
	}
	
/*if(!Hold(70)){break;}
			ObjAnim_SetAttackA2(Enemy, 240);
			if(!Hold(30)){break;}
			Lanes;
			if(!Hold(250)){break;}
			ObjMove_SetDestAtFrame(Enemy, GetStgFrameWidth, EnemyY, 15);
			while(ObjMove_GetSpeed(Enemy)>1.5){yield}
			ShiftScreenA1(200, 0, 120);
			
			if(!Hold(70)){break;}
			ObjAnim_SetAttackA2(Enemy, 240);
			if(!Hold(30)){break;}
			
			if(!Hold(250)){break;}
			ObjMove_SetDestAtFrame(Enemy, 200, EnemyY, 15);
			while(ObjMove_GetSpeed(Enemy)>1.5){yield}
			ShiftScreenA1(-200, 0, 120);*/