#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let imgEnemycutin = current~"YuugiCutinDairi.png"; 
let imgoverlay = current~"Filter.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(80);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	// ObjRender_SetPosition(Enemy, GetStgFrameWidth/2+42, -64, 0);
	ObjMove_SetDestAtWeight(Enemy, GetCommonData("StarX1", GetStgFrameWidth/2),
		GetCommonData("StarY1", GetStgFrameHeight/3), 13, 5);
			
	SetInvincibility(Enemy, 280, 10, 8);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
		yield;
	// loop(65){yield;}
	PlaySoundB1("se_cat00",60);
	ObjCutin_SetSpellcardM4("Intoxicating Aroma \"Drunken Stagger\"", 3500000, "YABUSAME", imgEnemycutin, 255, 192, 56);
	ObjEnemyBossScene_StartSpell(objScene);
	if(!Hold(90)) {break;}
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	ExplosionB2(Enemy,"CHERRY",[255, 192, 64],[255, 64, 64]);
	loop(90){yield;}
	yield;
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		ObjAnim_SetAttackA2(Enemy, 80);
		Hold(30);
		overlay;
		Hold(85);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			lane;
			wind;
			if (!Hold(200)) {break;}
			ConcentrationA1(Enemy,"CHERRY",60,4,150,[255,192,56]);
			PlaySoundB1("se_ch02",60);
			if (!Hold(100)) {break;}
			ObjAnim_SetAttackA2(Enemy, 350);
			if (!Hold(40)) {break;}
			wind2;
			if (!Hold(324)) {break;}
		}
		return;
			
	}
}

task lane{
	let pX = GetStgFrameWidth/2;
	let pY = GetStgFrameHeight/2;
	let ii = round(rand(1,2));
	ascent(j in 0..20){
		ascent(i in -2..3){
			let shot = CreateObjShotA2(EnemyX,EnemyY,0,atan2(pY-EnemyY,pX-EnemyX)+(i*40),0.03,3.5,97,15);
			ObjRender_SetBlendType(shot,BLEND_ADD_ARGB);
		}
		PlaySoundB1("c_shot",60);
		if (!Hold(12)) {break;}
		if(ObjEnemy_GetInfo(Enemy, INFO_LIFE) == 0){break} 
		if (j ==0) {if (ii == 1) {ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/3,GetStgFrameHeight/3-rand(0,40),13,1);} else {ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/3*2,GetStgFrameHeight/3-rand(0,40),13,1);}}
		if (j == 10) {ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2,GetStgFrameHeight/3-rand(0,40),13,1);}
	}
}

task wind{
	let dir = 0;
	loop(21){
		ascent(i in 0..4){
			let shot = CreateObjShotA1(-25,-25,2+rand(0,1),dir+i*360/4,261,0);
			ObjMove_SetAngularVelocity(shot,rand(-0.2,0));
			shot = CreateObjShotA1(GetStgFrameWidth+25,-25,2+rand(0,1),-dir+i*360/4,260,0);
			ObjMove_SetAngularVelocity(shot,rand(0,0.2));
		}
		dir+=360/4/3;
		PlaySoundB1("c_shot3",60);
		if (!Hold(16)) {break;}
		if(ObjEnemy_GetInfo(Enemy, INFO_LIFE) == 0){break} 
	}
	wait(60);
	
}

task wind2{
	let dir = 0;
	let count = 90;
	loop(37){
		ascent(i in 0..4){
			let shot = CreateObjShotA1(GetStgFrameWidth/2-(GetStgFrameWidth/2*sin(count)),-25,3+rand(0,1),dir+i*360/4,261,0);
			ObjMove_SetAngularVelocity(shot,rand(-0.2,0));
			shot = CreateObjShotA1(GetStgFrameWidth/2+(GetStgFrameWidth/2*sin(count)),-25,3+rand(0,1),-dir+i*360/4,260,0);
			ObjMove_SetAngularVelocity(shot,rand(0,0.2));
		}
		dir+=360/4/3;
		PlaySoundB1("c_shot3",60);
		if (!Hold(8)) {break;}
		if(ObjEnemy_GetInfo(Enemy, INFO_LIFE) == 0){break} 
		count+=360/37;
	}
}

task wobble {
	let sine = 90;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		sine+=2.4;
		ObjMove_SetX(GetPlayerObjectID,ObjMove_GetX(GetPlayerObjectID)+1.2*sin(sine));
		yield;
	}
}

task overlay{
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(obj,79);
	ObjPrim_SetTexture(obj,imgoverlay);
	ObjSprite2D_SetSourceRect(obj,0,0,512,512);
	ObjSprite2D_SetDestRect(obj,-256,-256,256,256);
	ObjRender_SetPosition(obj,EnemyX,EnemyY,0);
	ObjRender_SetScaleXYZ(obj,0,0,0);
	ObjRender_SetBlendType(obj,BLEND_ADD_ARGB);
	let count = 0;
	PlaySoundB1("se_boon01",60);
	loop(50){
		count+=2/60;
		ObjRender_SetScaleXYZ(obj,count,count,0);
		yield;
	}
	wobble;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	descent(i in 0..30){
		ObjRender_SetAlpha(obj, 255/29*i);
		yield;
	}
	Obj_Delete(obj);
}


function syield{
	if(!EnemyDead){yield;}else{break;}
}

